#pragma once
#include "TensileTypes.h"

// enqueue solution
TensileStatus tensile_Cijk_Alik_Bljk_SB(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// solution pointer
typedef TensileStatus (*TensileSolutionPointer_Cijk_Alik_Bljk_SB)(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// get solution pointer
TensileSolutionPointer_Cijk_Alik_Bljk_SB tensileGetSolutionPointer_Cijk_Alik_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);

// get solution name
const char * tensileGetSolutionName_Cijk_Alik_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);


// enqueue solution
TensileStatus tensile_Cijk_Ailk_Bljk_DB(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// solution pointer
typedef TensileStatus (*TensileSolutionPointer_Cijk_Ailk_Bljk_DB)(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// get solution pointer
TensileSolutionPointer_Cijk_Ailk_Bljk_DB tensileGetSolutionPointer_Cijk_Ailk_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);

// get solution name
const char * tensileGetSolutionName_Cijk_Ailk_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);


// enqueue solution
TensileStatus tensile_Cijk_Ailk_Bjlk_SB(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// solution pointer
typedef TensileStatus (*TensileSolutionPointer_Cijk_Ailk_Bjlk_SB)(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// get solution pointer
TensileSolutionPointer_Cijk_Ailk_Bjlk_SB tensileGetSolutionPointer_Cijk_Ailk_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);

// get solution name
const char * tensileGetSolutionName_Cijk_Ailk_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);


// enqueue solution
TensileStatus tensile_Cijk_Ailk_Bjlk_DB(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// solution pointer
typedef TensileStatus (*TensileSolutionPointer_Cijk_Ailk_Bjlk_DB)(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// get solution pointer
TensileSolutionPointer_Cijk_Ailk_Bjlk_DB tensileGetSolutionPointer_Cijk_Ailk_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);

// get solution name
const char * tensileGetSolutionName_Cijk_Ailk_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);


// enqueue solution
TensileStatus tensile_Cijk_Alik_Bjlk_DB(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// solution pointer
typedef TensileStatus (*TensileSolutionPointer_Cijk_Alik_Bjlk_DB)(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// get solution pointer
TensileSolutionPointer_Cijk_Alik_Bjlk_DB tensileGetSolutionPointer_Cijk_Alik_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);

// get solution name
const char * tensileGetSolutionName_Cijk_Alik_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);


// enqueue solution
TensileStatus tensile_Cijk_Alik_Bjlk_SB(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// solution pointer
typedef TensileStatus (*TensileSolutionPointer_Cijk_Alik_Bjlk_SB)(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// get solution pointer
TensileSolutionPointer_Cijk_Alik_Bjlk_SB tensileGetSolutionPointer_Cijk_Alik_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);

// get solution name
const char * tensileGetSolutionName_Cijk_Alik_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);


// enqueue solution
TensileStatus tensile_Cijk_Alik_Bljk_DB(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// solution pointer
typedef TensileStatus (*TensileSolutionPointer_Cijk_Alik_Bljk_DB)(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// get solution pointer
TensileSolutionPointer_Cijk_Alik_Bljk_DB tensileGetSolutionPointer_Cijk_Alik_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);

// get solution name
const char * tensileGetSolutionName_Cijk_Alik_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);


// enqueue solution
TensileStatus tensile_Cijk_Ailk_Bljk_SB(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// solution pointer
typedef TensileStatus (*TensileSolutionPointer_Cijk_Ailk_Bljk_SB)(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent);


// get solution pointer
TensileSolutionPointer_Cijk_Ailk_Bljk_SB tensileGetSolutionPointer_Cijk_Ailk_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);

// get solution name
const char * tensileGetSolutionName_Cijk_Ailk_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream);

