#include "Tensile.h"
#include "SolutionHelper.h"
#include <map>
#include <tuple>
typedef std::tuple<unsigned int, unsigned int, unsigned int> ProblemSizeKey;

size_t tensileProblemSizeHasher( const ProblemSizeKey & problemSize ) {
  size_t hash = 0;
  // ignore lowest 4 bits; keep next 21 bits
  size_t hash0 = (std::get<0>(problemSize) >> 4) & ((1<<22)-1); // 21 bits of size0
  size_t hash1 = (std::get<1>(problemSize) >> 4) & ((1<<22)-1); // 21 bits of size1
  size_t hashU = (std::get<2>(problemSize) >> 4) & ((1<<22)-1); // 21 bits of sizeU
  // 21+21+21 = 63 bit hash
  hash |= hash0;
  hash |= hash1<<21;
  hash |= hashU<<42;
  return hash;
}

typedef std::map<ProblemSizeKey, TensileSolutionPointer_Cijk_Alik_Bljk_SB> Map_Cijk_Alik_Bljk_SB;
extern Map_Cijk_Alik_Bljk_SB solutionMap_Cijk_Alik_Bljk_SB;
typedef std::map<ProblemSizeKey, TensileSolutionPointer_Cijk_Ailk_Bljk_DB> Map_Cijk_Ailk_Bljk_DB;
extern Map_Cijk_Ailk_Bljk_DB solutionMap_Cijk_Ailk_Bljk_DB;
typedef std::map<ProblemSizeKey, TensileSolutionPointer_Cijk_Ailk_Bjlk_SB> Map_Cijk_Ailk_Bjlk_SB;
extern Map_Cijk_Ailk_Bjlk_SB solutionMap_Cijk_Ailk_Bjlk_SB;
typedef std::map<ProblemSizeKey, TensileSolutionPointer_Cijk_Ailk_Bjlk_DB> Map_Cijk_Ailk_Bjlk_DB;
extern Map_Cijk_Ailk_Bjlk_DB solutionMap_Cijk_Ailk_Bjlk_DB;
typedef std::map<ProblemSizeKey, TensileSolutionPointer_Cijk_Alik_Bjlk_DB> Map_Cijk_Alik_Bjlk_DB;
extern Map_Cijk_Alik_Bjlk_DB solutionMap_Cijk_Alik_Bjlk_DB;
typedef std::map<ProblemSizeKey, TensileSolutionPointer_Cijk_Alik_Bjlk_SB> Map_Cijk_Alik_Bjlk_SB;
extern Map_Cijk_Alik_Bjlk_SB solutionMap_Cijk_Alik_Bjlk_SB;
typedef std::map<ProblemSizeKey, TensileSolutionPointer_Cijk_Alik_Bljk_DB> Map_Cijk_Alik_Bljk_DB;
extern Map_Cijk_Alik_Bljk_DB solutionMap_Cijk_Alik_Bljk_DB;
typedef std::map<ProblemSizeKey, TensileSolutionPointer_Cijk_Ailk_Bljk_SB> Map_Cijk_Ailk_Bljk_SB;
extern Map_Cijk_Ailk_Bljk_SB solutionMap_Cijk_Ailk_Bljk_SB;
