/*******************************************************************************
* Copyright (C) 2016 Advanced Micro Devices, Inc. All rights reserved.
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell cop-
* ies of the Software, and to permit persons to whom the Software is furnished
* to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all
* copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IM-
* PLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
* FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
* COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
* IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNE-
* CTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

/**************************************************
* This file was generated by Tensile:             *
* https://github.com/ROCmSoftwarePlatform/Tensile *
**************************************************/


#include "Solutions.h"
hipError_t Cijk_Alik_Bljk_SB_MT064x016x64_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x016x64_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x016x64_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x016x64_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x016x64_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT064x016x64_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 64
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 5120
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 4
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 4
  LVPB: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 16
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  SubGroup1: 4
  LVCA: 16
  ThreadTile: [4, 4]
  MacroTile0: 64
  LdsOffsetB: 4096
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT064x016x64_GSU32_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x016x64_GSU32_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x016x64_GSU32_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x016x64_GSU32_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x016x64_GSU32_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 32; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT064x016x64_GSU32_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 64
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 5120
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 4
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 4
  LVPB: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 32
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  SubGroup1: 4
  LVCA: 16
  ThreadTile: [4, 4]
  MacroTile0: 64
  LdsOffsetB: 4096
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT064x008x64_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_02_08_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x008x64_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_02_08_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x008x64_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_02_08_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x008x64_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_02_08_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x008x64_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_02_08_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 2 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT064x008x64_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_02_08_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 64
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4608
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 2
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 2, 8]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 8
  NumLoadsPerpendicularA: 4
  LVPB: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 16
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  SubGroup1: 2
  LVCA: 16
  ThreadTile: [4, 4]
  MacroTile0: 64
  LdsOffsetB: 4096
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT048x048x16_GSU08_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT048x048x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT048x048x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT048x048x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT048x048x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 3, 3 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT048x048x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 3
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 48
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 3
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 48
  LdsNumElements: 3584
  NumLoadsA: 3
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 3
  GlobalLoadVectorWidthA: 1
  VectorWidth: 1
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2816
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 3
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 9
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 3
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 48
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 9
  LdsNumElementsAlignedA: 768
  LVPB: 16
  LVCA: 16
  MacroTile0: 48
  ThreadTile: [3, 3]
  LdsNumElementsAlignedB: 768
  LdsOffsetB: 768
  NumLoadsPerpendicularB: 3
*/

hipError_t Cijk_Alik_Bljk_SB_MT036x048x16_GSU02_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT036x048x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT036x048x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT036x048x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT036x048x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 3, 3 };
  const unsigned int groupSize[2] = { 12, 16 };
  size_t localWorkSize[3] = { 192, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT036x048x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 3
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 48
  LSPB: 12
  PerformanceWaitCount: -1
  ThreadTile0: 3
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 36
  LdsNumElements: 3392
  NumLoadsA: 3
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 192
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 12
  ThreadTile1: 3
  GlobalLoadVectorWidthA: 1
  VectorWidth: 1
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2624
  LSCA: 16
  LSCB: 16
  LVPA: 12
  NonTemporalA: 0
  WorkGroup: [12, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 3
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 9
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 12
  PrefetchLocalRead: True
  SubGroup0: 12
  SubGroup1: 16
  ThreadTileA: 3
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 48
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 9
  LdsNumElementsAlignedA: 576
  LVPB: 12
  LVCA: 16
  MacroTile0: 36
  ThreadTile: [3, 3]
  LdsNumElementsAlignedB: 768
  LdsOffsetB: 576
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bljk_SB_MT036x048x16_GSU08_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT036x048x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT036x048x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT036x048x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT036x048x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 3, 3 };
  const unsigned int groupSize[2] = { 12, 16 };
  size_t localWorkSize[3] = { 192, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT036x048x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 3
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 48
  LSPB: 12
  PerformanceWaitCount: -1
  ThreadTile0: 3
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 36
  LdsNumElements: 3392
  NumLoadsA: 3
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 192
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 12
  ThreadTile1: 3
  GlobalLoadVectorWidthA: 1
  VectorWidth: 1
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2624
  LSCA: 16
  LSCB: 16
  LVPA: 12
  NonTemporalA: 0
  WorkGroup: [12, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 3
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 9
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 12
  PrefetchLocalRead: True
  SubGroup0: 12
  SubGroup1: 16
  ThreadTileA: 3
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 48
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 9
  LdsNumElementsAlignedA: 576
  LVPB: 12
  LVCA: 16
  MacroTile0: 36
  ThreadTile: [3, 3]
  LdsNumElementsAlignedB: 768
  LdsOffsetB: 576
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT064x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT064x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x032x08_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x032x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 8
  LSCB: 8
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 4
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT016x016x16_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT016x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 4
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1792
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 4
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT064x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT064x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 8
  LSCB: 8
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 16
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 4
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 4
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 4
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT096x128x16_GSU01_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 6, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 6
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 96
  LdsNumElements: 7680
  NumLoadsA: 3
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5632
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 3
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 6
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  LdsNumElementsAlignedA: 1536
  LVPB: 16
  LVCA: 8
  MacroTile0: 96
  ThreadTile: [6, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1536
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 128
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 8
  LSCB: 8
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 2
  LoopUnroll: 8
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  LdsNumElementsAlignedA: 1024
  LVPB: 32
  LVCA: 2
  MacroTile0: 128
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 128
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 8
  LSCB: 8
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 2
  LoopUnroll: 8
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  LdsNumElementsAlignedA: 1024
  LVPB: 32
  LVCA: 2
  MacroTile0: 128
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT008x008x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT008x008x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT008x008x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT008x008x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT008x008x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 4 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT008x008x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 8
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 64
  LVPB: 8
  LVCA: 8
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT008x008x08_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT008x008x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT008x008x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT008x008x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT008x008x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 4 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT008x008x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 8
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 64
  LVPB: 8
  LVCA: 8
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_DB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    double * dataC;
    const double * dataA;
    const double * dataB;
    double alpha;
    double beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_DB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_DB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_DB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_DB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bljk_DB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_DB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 8
  LSCB: 8
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_DB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 512
  LVPB: 32
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bljk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    double * dataC;
    const double * dataA;
    const double * dataB;
    double alpha;
    double beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_DB_MT064x064x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_DB_MT064x064x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bljk_DB_MT064x064x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bljk_DB_MT064x064x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bljk_DB_MT064x064x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bljk_DB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 4
  LSCB: 4
  LVPA: 64
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bljk_DB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 4
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 256
  LVPB: 64
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 3328
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2304
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 4
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x032x32_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 8
  LdsNumElements: 3328
  NumLoadsA: 1
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2304
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 4
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 8
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 8
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x064x16_GSU04_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x064x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 3328
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2304
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 4
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x08_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 8
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 8
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x08_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 16
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 640
  LSCA: 8
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 2
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 4
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 32, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 32
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 16
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [32, 4, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 32
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 4
  MacroTile0: 128
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 16
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 4
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 16
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 4
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 896
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 640
  LSCA: 16
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 8
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 896
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 640
  LSCA: 16
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 8
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 2048
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 2048
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x08_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 16
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 640
  LSCA: 8
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 2
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 4
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x08_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 16
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 640
  LSCA: 8
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 2
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 4
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 896
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 640
  LSCA: 16
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 8
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 896
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 640
  LSCA: 16
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 8
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x032x32_GSU02_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 8
  LdsNumElements: 3328
  NumLoadsA: 1
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2304
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 4
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x032x32_GSU02_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 8
  LdsNumElements: 3328
  NumLoadsA: 1
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2304
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 4
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 1664
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1152
  LSCA: 16
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 4
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 1664
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1152
  LSCA: 16
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 4
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x064x32_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 6656
  NumLoadsA: 1
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 4608
  LSCA: 32
  LSCB: 64
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x064x32_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 6656
  NumLoadsA: 1
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 4608
  LSCA: 32
  LSCB: 64
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x16_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x16_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x008x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x008x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x008x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 32, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6400
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 32
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 32
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [32, 4, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 32
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 32
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x008x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x008x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x008x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 32, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6400
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 32
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 32
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [32, 4, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 32
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 32
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 8
  LSCB: 64
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 4
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 8
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 256
  LVPB: 2
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 8
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 256
  LVPB: 2
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x128x08_GSU08_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_16_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x128x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x128x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x128x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x128x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x128x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_16_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2304
  LSCA: 8
  LSCB: 128
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 4
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 256
  LVPB: 2
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x128x08_GSU08_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_16_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x128x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x128x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x128x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x128x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x128x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_16_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2304
  LSCA: 8
  LSCB: 128
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 4
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 256
  LVPB: 2
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2304
  LSCA: 16
  LSCB: 64
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 2
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2304
  LSCA: 16
  LSCB: 64
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 2
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x32_GSU08_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 4
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 32
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 2
  LVCA: 8
  MacroTile0: 64
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x064x08_GSU02_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 16
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1152
  LSCA: 8
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 2
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 128
  LVPB: 2
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x064x08_GSU02_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x064x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 16
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1152
  LSCA: 8
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 2
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 128
  LVPB: 2
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x32_GSU08_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 4
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 32
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 2
  LVCA: 8
  MacroTile0: 64
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x016x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 8
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 32
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 8
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 32
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x016x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 8
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 32
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 8
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 4
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 8
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 4
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 8
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x016x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 8
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 32
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 8
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x016x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 8
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 32
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 8
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x08_GSU04_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 8
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 4
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 256
  LVPB: 2
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x08_GSU04_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 8
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 256
  LVPB: 2
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 16
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 4
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 32
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 8
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG16_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 4
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x064x32_GSU02_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 6656
  NumLoadsA: 1
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 4608
  LSCA: 32
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 2
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x064x32_GSU02_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 6656
  NumLoadsA: 1
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 4608
  LSCA: 32
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 2
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x32_GSU04_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 32
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x32_GSU04_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 32
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG32_04_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG32_04_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG32_04_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG32_04_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG32_04_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 32, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG32_04_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 3328
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 32
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [32, 4, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 32
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 8
  MacroTile0: 64
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x016x32_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 8
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 32
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 8
  LVCA: 16
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 32
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 32
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x24_GSU04_NLCA03_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x24_GSU04_ISA803_K1_NLCA03_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x24_GSU04_ISA803_K1_NLCA03_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x24_GSU04_ISA900_K1_NLCA03_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x24_GSU04_ISA900_K1_NLCA03_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x24_GSU04_ISA900_K1_NLCA03_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 24
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 3
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5632
  LSCA: 8
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 12
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 3
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1536
  LVPB: 2
  LVCA: 2
  MacroTile0: 64
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1536
  LdsOffsetB: 1536
  NumLoadsPerpendicularB: 3
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 7168
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 32
  LSCB: 64
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x008x32_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x008x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x008x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x008x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x008x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 32, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x008x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6400
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 32
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 32
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [32, 4, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 32
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 32
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x064x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 7168
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 32
  LSCB: 64
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x32_GSU02_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 4
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 32
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 2
  LVCA: 8
  MacroTile0: 64
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x32_GSU02_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 4
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 32
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 2
  LVCA: 8
  MacroTile0: 64
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x016x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 32
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x008x32_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x008x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x008x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x008x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x008x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 32, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x008x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG32_04_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6400
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 32
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 32
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [32, 4, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 32
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 32
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x016x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 32
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x24_GSU04_NLCA03_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x24_GSU04_ISA803_K1_NLCA03_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x24_GSU04_ISA803_K1_NLCA03_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x24_GSU04_ISA900_K1_NLCA03_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x24_GSU04_ISA900_K1_NLCA03_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x24_GSU04_ISA900_K1_NLCA03_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 24
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 3
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5632
  LSCA: 8
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 12
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 3
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1536
  LVPB: 2
  LVCA: 2
  MacroTile0: 64
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1536
  LdsOffsetB: 1536
  NumLoadsPerpendicularB: 3
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x064x32_GSU04_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 6656
  NumLoadsA: 1
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 4608
  LSCA: 32
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 2
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x064x32_GSU04_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 4, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG04_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 6656
  NumLoadsA: 1
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 4
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 4608
  LSCA: 32
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [4, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 2
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x032x08_GSU04_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 32, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 32
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 8
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [32, 4, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 4
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 32
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 2
  MacroTile0: 128
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x032x08_GSU04_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 32, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 32
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 8
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [32, 4, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 4
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 32
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 2
  MacroTile0: 128
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 4
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 8
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 3584
  NumLoadsA: 2
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 16
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 4
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1280
  LSCA: 16
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 4
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [2, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 16, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 16
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 32
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 8
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 32
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 8
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 512, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 512
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 4
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 8
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 8
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 32, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG32_04_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 32
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 16
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [32, 4, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 32
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 4
  MacroTile0: 128
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 8
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x16_GSU02_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 64
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x16_GSU02_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGMn4 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 64
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  SubGroup1: 16
  LVCA: 4
  ThreadTile: [4, 4]
  MacroTile0: 64
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  SubGroup1: 16
  LVCA: 4
  ThreadTile: [4, 4]
  MacroTile0: 64
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 8
  LSCB: 64
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_NLCA01_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 6, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 4
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 96
  LdsNumElements: 3584
  NumLoadsA: 3
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 6
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 16
  LSCB: 128
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 3
  LVPB: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 64
  LoopUnroll: 16
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 6
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  SubGroup1: 16
  LVCA: 8
  ThreadTile: [6, 8]
  MacroTile0: 96
  LdsOffsetB: 1536
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 3072
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  LVPB: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 4
  ThreadTile: [8, 4]
  MacroTile0: 128
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_NLCA01_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 6, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 4
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 96
  LdsNumElements: 3584
  NumLoadsA: 3
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 6
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 16
  LSCB: 128
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 3
  LVPB: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 64
  LoopUnroll: 16
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 6
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  SubGroup1: 16
  LVCA: 8
  ThreadTile: [6, 8]
  MacroTile0: 96
  LdsOffsetB: 1536
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 16
  LSCB: 128
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  LVPB: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  SubGroup1: 16
  LVCA: 4
  ThreadTile: [8, 8]
  MacroTile0: 128
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 3072
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  LVPB: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 4
  ThreadTile: [8, 4]
  MacroTile0: 128
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 16
  LSCB: 128
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  LVPB: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  SubGroup1: 16
  LVCA: 4
  ThreadTile: [8, 8]
  MacroTile0: 128
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_ISA803_K1_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_ISA803_K1_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_ISA900_K1_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_ISA900_K1_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_ISA900_K1_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 24
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 6144
  NumLoadsA: 3
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 8
  LSCB: 128
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 24
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 3
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  SubGroup1: 16
  LVCA: 2
  ThreadTile: [8, 8]
  MacroTile0: 128
  LdsOffsetB: 3072
  NumLoadsPerpendicularB: 3
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 1536
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 8
  LSCB: 64
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 2
  ThreadTile: [8, 4]
  MacroTile0: 128
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 6, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 6
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 96
  LdsNumElements: 7680
  NumLoadsA: 3
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5632
  LSCA: 16
  LSCB: 128
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 3
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 64
  LoopUnroll: 16
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 6
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  LdsNumElementsAlignedA: 1536
  LVPB: 2
  LVCA: 8
  MacroTile0: 96
  ThreadTile: [6, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1536
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 1536
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 8
  LSCB: 64
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 8
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 2
  ThreadTile: [8, 4]
  MacroTile0: 128
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 8
  LSCB: 64
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 2
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 6, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 6
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 96
  LdsNumElements: 7680
  NumLoadsA: 3
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5632
  LSCA: 16
  LSCB: 128
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 3
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 64
  LoopUnroll: 16
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 6
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  LdsNumElementsAlignedA: 1536
  LVPB: 2
  LVCA: 8
  MacroTile0: 96
  ThreadTile: [6, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1536
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 8
  LSCB: 64
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 8
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 2
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 8
  LSCB: 64
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_ISA803_K1_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_ISA803_K1_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_ISA900_K1_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_ISA900_K1_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_ISA900_K1_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 24
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 6144
  NumLoadsA: 3
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 8
  LSCB: 128
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 24
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 3
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  SubGroup1: 16
  LVCA: 2
  ThreadTile: [8, 8]
  MacroTile0: 128
  LdsOffsetB: 3072
  NumLoadsPerpendicularB: 3
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 8
  LSCB: 128
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 512
  LVPB: 2
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 1536
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 8
  LSCB: 128
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 4
  ThreadTile: [4, 8]
  MacroTile0: 64
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 8
  LSCB: 128
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 512
  LVPB: 2
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 1536
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 8
  LSCB: 128
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 4
  ThreadTile: [4, 8]
  MacroTile0: 64
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 3072
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 16
  LSCB: 128
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 4
  ThreadTile: [4, 8]
  MacroTile0: 64
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 8
  LSCB: 64
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  SubGroup1: 16
  LVCA: 4
  ThreadTile: [4, 4]
  MacroTile0: 64
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 16
  LSCB: 128
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  LdsNumElementsAlignedA: 2048
  LVPB: 2
  LVCA: 4
  MacroTile0: 128
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 3072
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 16
  LSCB: 128
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 4
  ThreadTile: [4, 8]
  MacroTile0: 64
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 16
  LSCB: 128
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  LdsNumElementsAlignedA: 2048
  LVPB: 2
  LVCA: 4
  MacroTile0: 128
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 8
  LSCB: 64
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  SubGroup1: 16
  LVCA: 4
  ThreadTile: [4, 4]
  MacroTile0: 64
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 6 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 6
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 96
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 7680
  NumLoadsA: 4
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 6
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 16
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 96
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 3
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 8
  MacroTile0: 128
  ThreadTile: [8, 6]
  LdsNumElementsAlignedB: 1536
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 16
  LSCB: 128
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 4
  LVCA: 4
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 16
  LSCB: 128
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 8
  LSCB: 128
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 8
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  SubGroup1: 16
  LVCA: 2
  ThreadTile: [8, 8]
  MacroTile0: 128
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 8
  LSCB: 128
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  SubGroup1: 16
  LVCA: 2
  ThreadTile: [8, 8]
  MacroTile0: 128
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 8
  LSCB: 128
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 32
  LoopUnroll: 8
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 2
  MacroTile0: 128
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 8
  LSCB: 128
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 128
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 2
  MacroTile0: 128
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 6 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 6
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 96
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 7680
  NumLoadsA: 4
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 6
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 16
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 96
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 3
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 8
  MacroTile0: 128
  ThreadTile: [8, 6]
  LdsNumElementsAlignedB: 1536
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_NLCA01_NLCB03_PGR0_TT08_06_VW02_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB03_PGR0_TT08_06_VW02_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB03_PGR0_TT08_06_VW02_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR0_TT08_06_VW02_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR0_TT08_06_VW02_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 6 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR0_TT08_06_VW02_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 6
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 96
  LSPB: 16
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 3584
  NumLoadsA: 4
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 16
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 4
  LVPB: 8
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 6
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 96
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 3
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  SubGroup1: 16
  LVCA: 8
  ThreadTile: [8, 6]
  MacroTile0: 128
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_NLCA01_NLCB03_PGR0_TT08_06_VW02_WG16_16_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB03_PGR0_TT08_06_VW02_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB03_PGR0_TT08_06_VW02_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR0_TT08_06_VW02_WG16_16_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR0_TT08_06_VW02_WG16_16_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 6 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR0_TT08_06_VW02_WG16_16_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 6
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 96
  LSPB: 16
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 3584
  NumLoadsA: 4
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 16
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 4
  LVPB: 8
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 6
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 96
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 3
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  SubGroup1: 16
  LVCA: 8
  ThreadTile: [8, 6]
  MacroTile0: 128
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 16
  LSCB: 64
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: -4
  LVCB: 16
  LoopUnroll: 16
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 4
  LVCA: 4
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x08_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 8
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x04_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x04_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x04_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 4
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 128
  LVPB: 4
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x04_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x04_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x04_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 4
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 128
  LVPB: 4
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x02_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x02_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x02_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x02_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x02_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x02_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 2
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 2
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 2
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 64
  LVPB: 2
  LVCA: 2
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x08_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 8
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 8
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x04_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x04_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x04_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x04_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x04_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x04_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 4
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 128
  LVPB: 4
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x08_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 8
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x08_GSU01_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 8
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 8
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x04_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x04_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x04_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 4
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 64
  LVPB: 4
  LVCA: 4
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x04_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x04_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x04_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x04_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x04_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x04_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 4
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 64
  LVPB: 4
  LVCA: 4
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x16_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x04_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x04_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x04_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x04_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x04_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x04_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 4
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 128
  LVPB: 4
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x02_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x02_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x02_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x02_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x02_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x02_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 2
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 2
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 2
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 64
  LVPB: 2
  LVCA: 2
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x02_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x02_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x02_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x02_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x02_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x02_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 2
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 2
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 2
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 64
  LVPB: 2
  LVCA: 2
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x02_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x02_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x02_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x02_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x02_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x02_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 2
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 2
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 2
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 64
  LVPB: 2
  LVCA: 2
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x008x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x008x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x008x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x008x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x008x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 4 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x008x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 8
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 64
  LVPB: 8
  LVCA: 8
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x008x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x008x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x008x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x008x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x008x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 4 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x008x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 8
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 64
  LVPB: 8
  LVCA: 8
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x008x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x008x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x008x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x008x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x008x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 4 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x008x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 8
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 64
  LVPB: 8
  LVCA: 8
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x04_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x04_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x04_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 4
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 64
  LVPB: 4
  LVCA: 4
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x008x08_GSU01_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x008x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x008x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x008x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x008x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 4 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x008x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 8
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 64
  LVPB: 8
  LVCA: 8
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 8
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 8
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x04_GSU01_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 4
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 64
  LVPB: 4
  LVCA: 4
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x04_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x04_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x04_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x04_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x04_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x04_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 4
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 64
  LVPB: 4
  LVCA: 4
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT008x008x08_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x008x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x008x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT008x008x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT008x008x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 4 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT008x008x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 8
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 64
  LVPB: 8
  LVCA: 8
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 4
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 128
  LVPB: 4
  LVCA: 4
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x02_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x02_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x02_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x02_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x02_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x02_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 2
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 2
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 2
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 64
  LVPB: 2
  LVCA: 2
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT016x016x16_GSU01_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT016x016x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_SB_MT016x016x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_SB_MT032x032x08_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups1;
  globalWorkSize[0][1] = totalWorkGroups0;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Alik_Bjlk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGMn1 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1I = strideA1I;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 8
  LSCB: 32
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: -1
  LVCB: 32
  LoopUnroll: 2
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_DB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    double * dataC;
    const double * dataA;
    const double * dataB;
    double alpha;
    double beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_DB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_DB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_DB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_DB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_DB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_DB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 8
  LSCB: 64
  LVPA: 32
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_DB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 32
  LoopUnroll: 8
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Alik_Bjlk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    double * dataC;
    const double * dataA;
    const double * dataB;
    double alpha;
    double beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1I;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_DB_MT064x064x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_DB_MT064x064x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Alik_Bjlk_DB_MT064x064x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Alik_Bjlk_DB_MT064x064x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Alik_Bjlk_DB_MT064x064x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1I = strideA1I;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Alik_Bjlk_DB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 4
  LSCB: 64
  LVPA: 64
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Alik_Bjlk_DB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 64
  LoopUnroll: 4
  LSPA: 64
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 256
  LVPB: 4
  LVCA: 4
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 2
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1280
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  SubGroupB: 4
  ThreadTile0: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  LVPB: 8
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 2
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 16
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  SubGroup1: 4
  LVCA: 16
  ThreadTile: [2, 2]
  MacroTile0: 32
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x008x32_GSU32_NLCA01_NLCB01_PGR0_TT04_02_VW02_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x008x32_GSU32_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU32_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x008x32_GSU32_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU32_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 32; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x008x32_GSU32_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_02_VW02_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 2
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 2304
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  SubGroupB: 4
  ThreadTile0: 4
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 4
  LVPB: 8
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 2
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 32
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  SubGroup1: 4
  LVCA: 32
  ThreadTile: [4, 2]
  MacroTile0: 64
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x008x64_GSU32_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_04_08_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x008x64_GSU32_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_04_08_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x008x64_GSU32_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_04_08_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x008x64_GSU32_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_04_08_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x008x64_GSU32_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_04_08_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 32; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x008x64_GSU32_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_04_08_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 64
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 6656
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 32
  LSCB: 64
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 4, 8]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 8
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 32
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 4
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 32, 2 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4352
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 32
  SubGroupB: 2
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 32
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [32, 2, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 4
  LVPB: 8
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 32
  ThreadTileB: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 16
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  SubGroup1: 2
  LVCA: 32
  ThreadTile: [4, 4]
  MacroTile0: 128
  LdsOffsetB: 4096
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x64_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x64_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x64_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x64_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x64_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x64_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 64
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 5120
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 4
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 4
  LVPB: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 16
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  SubGroup1: 4
  LVCA: 16
  ThreadTile: [4, 4]
  MacroTile0: 64
  LdsOffsetB: 4096
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3328
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x016x16_GSU16_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 2
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4096
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  SubGroupB: 8
  ThreadTile0: 8
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  LVPB: 16
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 2
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 16
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  SubGroup1: 8
  LVCA: 64
  ThreadTile: [8, 2]
  MacroTile0: 128
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x32_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6656
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x008x32_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_02_08_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x008x32_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_02_08_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_02_08_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x008x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_02_08_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_02_08_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 2 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x008x32_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_02_08_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 2
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6400
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 2, 8]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 8
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 2
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x004x64_GSU16_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG32_02_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x004x64_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG32_02_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x004x64_GSU16_ISA803_K1_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG32_02_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x004x64_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG32_02_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x004x64_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG32_02_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 32, 2 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x004x64_GSU16_ISA900_K1_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG32_02_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 2
  DepthU: 64
  GlobalReadCoalesceVectorA: True
  MacroTileB: 4
  LSPB: 4
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4352
  NumLoadsA: 8
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 32
  SubGroupB: 2
  ThreadTile0: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [32, 2, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 8
  LVPB: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 64
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 32
  ThreadTileB: 2
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 4
  GlobalSplitU: 16
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  SubGroup1: 2
  LVCA: 32
  ThreadTile: [2, 2]
  MacroTile0: 64
  LdsOffsetB: 4096
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x008x32_GSU32_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x008x32_GSU32_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x008x32_GSU32_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x008x32_GSU32_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x008x32_GSU32_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 2 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 32; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x008x32_GSU32_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 2
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4352
  NumLoadsA: 8
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  SubGroupB: 4
  ThreadTile0: 8
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 32
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 8
  LVPB: 8
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 2
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 32
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  SubGroup1: 4
  LVCA: 64
  ThreadTile: [8, 2]
  MacroTile0: 128
  LdsOffsetB: 4096
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT048x048x16_GSU08_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT048x048x16_GSU08_ISA803_K1_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT048x048x16_GSU08_ISA803_K1_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT048x048x16_GSU08_ISA900_K1_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT048x048x16_GSU08_ISA900_K1_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 3, 3 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT048x048x16_GSU08_ISA900_K1_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 3
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 48
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 3
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 48
  LdsNumElements: 3584
  NumLoadsA: 3
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 3
  GlobalLoadVectorWidthA: 1
  VectorWidth: 1
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2816
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 9
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 3
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 48
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 3
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 9
  LdsNumElementsAlignedA: 768
  LVPB: 16
  LVCA: 16
  MacroTile0: 48
  ThreadTile: [3, 3]
  LdsNumElementsAlignedB: 768
  LdsOffsetB: 768
  NumLoadsPerpendicularB: 3
*/

hipError_t Cijk_Ailk_Bljk_SB_MT048x036x16_GSU02_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT048x036x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT048x036x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT048x036x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT048x036x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 6, 3 };
  const unsigned int groupSize[2] = { 8, 12 };
  size_t localWorkSize[3] = { 192, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT048x036x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 3
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 12
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 36
  LSPB: 12
  PerformanceWaitCount: -1
  ThreadTile0: 6
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 48
  LdsNumElements: 3456
  NumLoadsA: 4
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 192
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 3
  GlobalLoadVectorWidthA: 1
  VectorWidth: 1
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2816
  LSCA: 48
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 12, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 9
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 12
  ThreadTileA: 6
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 36
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 9
  LdsNumElementsAlignedA: 768
  LVPB: 12
  LVCA: 48
  MacroTile0: 48
  ThreadTile: [6, 3]
  LdsNumElementsAlignedB: 576
  LdsOffsetB: 768
  NumLoadsPerpendicularB: 3
*/

hipError_t Cijk_Ailk_Bljk_SB_MT048x036x16_GSU04_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT048x036x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT048x036x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT048x036x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT048x036x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 6, 3 };
  const unsigned int groupSize[2] = { 8, 12 };
  size_t localWorkSize[3] = { 192, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT048x036x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 3
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 12
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 36
  LSPB: 12
  PerformanceWaitCount: -1
  ThreadTile0: 6
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 48
  LdsNumElements: 3456
  NumLoadsA: 4
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 192
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 3
  GlobalLoadVectorWidthA: 1
  VectorWidth: 1
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2816
  LSCA: 48
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 12, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 9
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 12
  ThreadTileA: 6
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 36
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 9
  LdsNumElementsAlignedA: 768
  LVPB: 12
  LVCA: 48
  MacroTile0: 48
  ThreadTile: [6, 3]
  LdsNumElementsAlignedB: 576
  LdsOffsetB: 768
  NumLoadsPerpendicularB: 3
*/

hipError_t Cijk_Ailk_Bljk_SB_MT048x036x16_GSU08_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT048x036x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT048x036x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT048x036x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT048x036x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 6, 3 };
  const unsigned int groupSize[2] = { 8, 12 };
  size_t localWorkSize[3] = { 192, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT048x036x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 3
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 12
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 36
  LSPB: 12
  PerformanceWaitCount: -1
  ThreadTile0: 6
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 48
  LdsNumElements: 3456
  NumLoadsA: 4
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 192
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 3
  GlobalLoadVectorWidthA: 1
  VectorWidth: 1
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2816
  LSCA: 48
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 12, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 9
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 12
  ThreadTileA: 6
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 36
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 9
  LdsNumElementsAlignedA: 768
  LVPB: 12
  LVCA: 48
  MacroTile0: 48
  ThreadTile: [6, 3]
  LdsNumElementsAlignedB: 576
  LdsOffsetB: 768
  NumLoadsPerpendicularB: 3
*/

hipError_t Cijk_Ailk_Bljk_SB_MT036x048x16_GSU08_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT036x048x16_GSU08_ISA803_K1_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT036x048x16_GSU08_ISA803_K1_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT036x048x16_GSU08_ISA900_K1_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT036x048x16_GSU08_ISA900_K1_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 3, 3 };
  const unsigned int groupSize[2] = { 12, 16 };
  size_t localWorkSize[3] = { 192, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT036x048x16_GSU08_ISA900_K1_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 3
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 48
  LSPB: 12
  PerformanceWaitCount: -1
  ThreadTile0: 3
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 36
  LdsNumElements: 3392
  NumLoadsA: 3
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 192
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 12
  ThreadTile1: 3
  GlobalLoadVectorWidthA: 1
  VectorWidth: 1
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2624
  LSCA: 12
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [12, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 9
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 12
  SubGroup1: 16
  ThreadTileA: 3
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 48
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 3
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 9
  LdsNumElementsAlignedA: 576
  LVPB: 12
  LVCA: 12
  MacroTile0: 36
  ThreadTile: [3, 3]
  LdsNumElementsAlignedB: 768
  LdsOffsetB: 576
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 32, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 6400
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 32
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [32, 4, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 32
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6656
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x008x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x008x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x008x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x008x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3328
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 3328
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x008x32_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x008x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x008x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x008x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6400
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x032x16_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6656
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x08_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 16
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 32
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6656
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x32_GSU08_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 4
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 2048
  LVPB: 4
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x08_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x08_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 3328
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6656
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6656
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x064x16_GSU02_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x064x16_GSU02_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x064x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 4
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 2048
  LVPB: 4
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x064x16_GSU04_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x064x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 4
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 2048
  LVPB: 4
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6656
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x32_GSU04_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 4
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 2048
  LVPB: 4
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x32_GSU04_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 4
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 2048
  LVPB: 4
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x032x16_GSU04_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x064x32_GSU04_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 4
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 4
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x032x16_GSU04_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x064x32_GSU04_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x064x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 4
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 4
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1792
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1792
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3328
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3328
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 32
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 16
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 32, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 6400
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 32
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [32, 4, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 32
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 16
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6656
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x08_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6656
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x08_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 32, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 6400
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 32
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [32, 4, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 32
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x08_GSU04_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 64
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 32
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x08_GSU04_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 8192
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 64
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 512
  LVPB: 32
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x08_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x08_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x032x16_GSU08_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x032x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x032x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x032x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x032x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x032x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x032x16_GSU08_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x032x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x032x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x032x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x032x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x032x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x008x32_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x008x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6400
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x008x32_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x008x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x008x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6400
  NumLoadsA: 4
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 32
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 4
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 4
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 16
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 3328
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_04_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 16
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 1792
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x08_GSU08_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 64
  LSCB: 8
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x032x08_GSU08_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x032x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 64
  LSCB: 8
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 128
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 8
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 32
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 2
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [8, 8]
  MacroTile0: 128
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 16
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  SubGroup1: 16
  LVCA: 16
  ThreadTile: [4, 4]
  MacroTile0: 64
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 6, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 6
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 96
  LdsNumElements: 7680
  NumLoadsA: 3
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5632
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 6
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 3
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  LdsNumElementsAlignedA: 1536
  LVPB: 16
  LVCA: 16
  MacroTile0: 96
  ThreadTile: [6, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1536
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 1536
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 8
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 32
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [8, 4]
  MacroTile0: 128
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 128
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 8
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 32
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 2
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [8, 8]
  MacroTile0: 128
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 16
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  SubGroup1: 16
  LVCA: 16
  ThreadTile: [4, 4]
  MacroTile0: 64
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 1536
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 8
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 32
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [8, 4]
  MacroTile0: 128
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 3072
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  LVPB: 16
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [8, 4]
  MacroTile0: 128
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 128
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 64
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 2
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 512
  LVPB: 32
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_04_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 3072
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  LVPB: 16
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [8, 4]
  MacroTile0: 128
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 128
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 2560
  LSCA: 64
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 2
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 512
  LVPB: 32
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 128
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 1536
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 32
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 2
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [4, 8]
  MacroTile0: 64
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 32
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [4, 4]
  MacroTile0: 64
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 128
  LSCB: 8
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 32
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 64
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 3072
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 16
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 16
  ThreadTile: [4, 8]
  MacroTile0: 64
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 32
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [4, 4]
  MacroTile0: 64
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 3584
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 128
  LSCB: 8
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 32
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 8192
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 128
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 1536
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 32
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 2
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [4, 8]
  MacroTile0: 64
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT04_08_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 64
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 3072
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 16
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  SubGroup1: 16
  LVCA: 16
  ThreadTile: [4, 8]
  MacroTile0: 64
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 6 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 6
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 96
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 7680
  NumLoadsA: 4
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 6
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 16
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 96
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 64
  MacroTile0: 128
  ThreadTile: [8, 6]
  LdsNumElementsAlignedB: 1536
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 3
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 64
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 512
  LVPB: 32
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 6 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 6
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 96
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 7680
  NumLoadsA: 4
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 6
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 96
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 64
  MacroTile0: 128
  ThreadTile: [8, 6]
  LdsNumElementsAlignedB: 1536
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 3
*/

hipError_t Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 64
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 512
  LVPB: 32
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_ISA803_K1_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_ISA803_K1_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_ISA900_K1_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_ISA900_K1_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_ISA900_K1_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 24
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 128
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 6144
  NumLoadsA: 3
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 8
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 3
  LVPB: 32
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 2
  LoopUnroll: 24
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 3
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [8, 8]
  MacroTile0: 128
  LdsOffsetB: 3072
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 128
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 128
  LSCB: 8
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 2
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  LdsNumElementsAlignedA: 1024
  LVPB: 32
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_ISA803_K1_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_ISA803_K1_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_ISA900_K1_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_ISA900_K1_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_ISA900_K1_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 24
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 128
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 6144
  NumLoadsA: 3
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 8
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 3
  LVPB: 32
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 2
  LoopUnroll: 24
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 3
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [8, 8]
  MacroTile0: 128
  LdsOffsetB: 3072
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 6, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 6
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 96
  LdsNumElements: 7680
  NumLoadsA: 3
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5632
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 6
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 3
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  LdsNumElementsAlignedA: 1536
  LVPB: 16
  LVCA: 16
  MacroTile0: 96
  ThreadTile: [6, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1536
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 128
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 128
  LSCB: 8
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 2
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  LdsNumElementsAlignedA: 1024
  LVPB: 32
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_NLCA03_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA03_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA03_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 6, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 32
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 96
  LdsNumElements: 3584
  NumLoadsA: 3
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 6
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 16
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 6
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 3
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  SubGroup1: 16
  LVCA: 16
  ThreadTile: [6, 8]
  MacroTile0: 96
  LdsOffsetB: 1536
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_NLCA03_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA03_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA03_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 6, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR0_TT06_08_VW02_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 32
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 96
  LdsNumElements: 3584
  NumLoadsA: 3
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 6
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  LVPB: 16
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 6
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 3
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  SubGroup1: 16
  LVCA: 16
  ThreadTile: [6, 8]
  MacroTile0: 96
  LdsOffsetB: 1536
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 64
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  LVPB: 16
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [8, 8]
  MacroTile0: 128
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR0_TT08_06_VW02_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_06_VW02_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_06_VW02_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_06_VW02_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_06_VW02_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 6 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_06_VW02_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 6
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 96
  LSPB: 32
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 3584
  NumLoadsA: 4
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 4
  LVPB: 16
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 6
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 96
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  SubGroup1: 16
  LVCA: 64
  ThreadTile: [8, 6]
  MacroTile0: 128
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 3
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 64
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4096
  NumLoadsA: 2
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  LVPB: 16
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 8
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  SubGroup1: 16
  LVCA: 32
  ThreadTile: [8, 8]
  MacroTile0: 128
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR0_TT08_06_VW02_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_06_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR0_TT08_06_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_06_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_06_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 6 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR0_TT08_06_VW02_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: False
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  ThreadTile1: 6
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 96
  LSPB: 32
  PerformanceWaitCount: -1
  GlobalLoadVectorWidthA: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 3584
  NumLoadsA: 4
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  SubGroupB: 16
  ThreadTile0: 8
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LSCA: 128
  LSCB: 16
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 4
  LVPB: 16
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 16
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 16
  ThreadTileB: 6
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 96
  GlobalSplitU: 1
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  SubGroup1: 16
  LVCA: 64
  ThreadTile: [8, 6]
  MacroTile0: 128
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 3
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x04_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x04_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x04_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x04_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x04_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x04_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 16
  LSCB: 4
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 4
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 64
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x04_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x04_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x04_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 16
  LSCB: 4
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 4
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 64
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 16
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x04_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x04_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x04_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 16
  LSCB: 4
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 4
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 64
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x02_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x02_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x02_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x02_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x02_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x02_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 2
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 32
  LSCB: 2
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 2
  LoopUnroll: 2
  LSPA: 2
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 64
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x02_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x02_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x02_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x02_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x02_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x02_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 2
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 32
  LSCB: 2
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 2
  LoopUnroll: 2
  LSPA: 2
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 64
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x04_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x04_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x04_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 32
  LSCB: 4
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 2
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 128
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x04_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x04_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x04_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 32
  LSCB: 4
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 2
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 128
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x16_GSU01_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x02_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x02_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x02_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x02_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x02_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x02_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 2
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 32
  LSCB: 2
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 2
  LoopUnroll: 2
  LSPA: 2
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 64
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x04_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x04_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x04_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x04_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x04_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x04_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 32
  LSCB: 4
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 2
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 128
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x04_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x04_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x04_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x04_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x04_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x04_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 16
  LSCB: 4
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 4
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 64
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x04_GSU01_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 16
  LSCB: 4
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 4
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 64
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x08_GSU01_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 16
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x08_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 32
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x02_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x02_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x02_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x02_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x02_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x02_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 2
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 32
  LSCB: 2
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 2
  LoopUnroll: 2
  LSPA: 2
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 64
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x04_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x04_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x04_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x04_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x04_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x04_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 32
  LSCB: 4
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 2
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 128
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT008x008x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT008x008x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT008x008x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT008x008x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT008x008x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 4 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT008x008x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 8
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 64
  LVPB: 8
  LVCA: 8
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT008x008x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT008x008x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT008x008x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT008x008x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT008x008x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 4 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT008x008x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 8
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 64
  LVPB: 8
  LVCA: 8
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT008x008x08_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT008x008x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT008x008x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT008x008x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT008x008x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 4 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT008x008x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 8
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 64
  LVPB: 8
  LVCA: 8
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x02_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x02_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x02_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x02_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x02_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x02_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 2
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 32
  LSCB: 2
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 2
  LoopUnroll: 2
  LSPA: 2
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 64
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT008x008x08_GSU01_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT008x008x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT008x008x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT008x008x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT008x008x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 4 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT008x008x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 8
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 64
  LVPB: 8
  LVCA: 8
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT032x032x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT032x032x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT032x032x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_SB_MT032x032x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 4
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 4
  PVB: 4
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 32
  LSCB: 4
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 4
  LoopUnroll: 2
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 128
  LVPB: 32
  LVCA: 32
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_SB_MT008x008x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT008x008x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT008x008x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_SB_MT008x008x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_SB_MT008x008x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 4 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bljk_SB_MT008x008x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1J = strideB1J;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 8
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 64
  LVPB: 8
  LVCA: 8
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_DB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    double * dataC;
    const double * dataA;
    const double * dataB;
    double alpha;
    double beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_DB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_DB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_DB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_DB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_DB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_DB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 64
  LSCB: 8
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_DB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 512
  LVPB: 32
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bljk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    double * dataC;
    const double * dataA;
    const double * dataB;
    double alpha;
    double beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1J;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_DB_MT064x064x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_DB_MT064x064x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bljk_DB_MT064x064x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bljk_DB_MT064x064x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bljk_DB_MT064x064x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1J = strideB1J;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bljk_DB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 64
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 64
  LSCB: 4
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bljk_DB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 4
  LoopUnroll: 4
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 256
  LVPB: 64
  LVCA: 64
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT032x008x32_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x008x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x008x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x008x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x008x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT032x008x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3328
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 32
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6656
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 8
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 32
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 8
  MacroTile0: 32
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 16
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 8
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 1
  MacroTileA: 16
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 32
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 8
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x016x16_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT032x016x16_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 512
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6656
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 4 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 6656
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 64
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 4
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 2048
  LVPB: 16
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 16
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 8
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 2; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 32
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 32
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 8
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 32
  GlobalSplitU: 2
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 1024
  LVPB: 8
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 128, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 512
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 128
  LdsOffsetA_Blk: 256
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 384
  LSCA: 16
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 2]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 2
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 128
  LVPB: 8
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 128
  LdsOffsetB: 128
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 32
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 32
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 32
  LdsNumElements: 3584
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 2
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 32
  LSCB: 16
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 2
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 8
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 1024
  LVPB: 16
  LVCA: 16
  MacroTile0: 32
  ThreadTile: [4, 2]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 64
  LSCB: 128
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 7168
  NumLoadsA: 1
  NumLoadsB: 2
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5120
  LSCA: 64
  LSCB: 128
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 32
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 2
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 64
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 4
  LdsNumElementsAlignedA: 1024
  LVPB: 4
  LVCA: 16
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 64
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 16
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 4
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 7168
  NumLoadsA: 2
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 64
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 2
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 32
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 2048
  LVPB: 4
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 4]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT128x096x16_GSU01_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT128x096x16_GSU01_ISA803_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 6 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bjlk_SB_MT128x096x16_GSU01_ISA900_K1_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 6
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 96
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 7680
  NumLoadsA: 4
  NumLoadsB: 3
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 6
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 6144
  LSCA: 128
  LSCB: 32
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 4
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 16
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 96
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 3
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  LdsNumElementsAlignedA: 2048
  LVPB: 8
  LVCA: 64
  MacroTile0: 128
  ThreadTile: [8, 6]
  LdsNumElementsAlignedB: 1536
  LdsOffsetB: 2048
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 128
  LSCB: 128
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 32
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT096x128x16_GSU01_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT096x128x16_GSU01_ISA803_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 6, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bjlk_SB_MT096x128x16_GSU01_ISA900_K1_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 6
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 96
  LdsNumElements: 7680
  NumLoadsA: 3
  NumLoadsB: 4
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 4096
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 5632
  LSCA: 32
  LSCB: 128
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 48
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 64
  LoopUnroll: 16
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 6
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 3
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 24
  LdsNumElementsAlignedA: 1536
  LVPB: 2
  LVCA: 16
  MacroTile0: 96
  ThreadTile: [6, 8]
  LdsNumElementsAlignedB: 2048
  LdsOffsetB: 1536
  NumLoadsPerpendicularB: 4
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 8, 8 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 8
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 128
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 8
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 4
  PVA: 1
  MacroTileA: 128
  LdsNumElements: 4096
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 2048
  GlobalLoadVectorWidthB: 4
  SubGroupA: 16
  ThreadTile1: 8
  GlobalLoadVectorWidthA: 4
  VectorWidth: 4
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 3072
  LSCA: 128
  LSCB: 128
  LVPA: 2
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 64
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 32
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 8
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 128
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 16
  LdsNumElementsAlignedA: 1024
  LVPB: 2
  LVCA: 32
  MacroTile0: 128
  ThreadTile: [8, 8]
  LdsNumElementsAlignedB: 1024
  LdsOffsetB: 1024
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU08_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 8; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU08_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 16
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 8
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 64
  LVPB: 4
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU04_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 4; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU04_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 16
  LSCB: 16
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [8, 8, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 4
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 4
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 2
  LdsNumElementsAlignedA: 64
  LVPB: 4
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT008x008x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT008x008x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT008x008x08_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT008x008x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT008x008x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 4, 4 };
  size_t localWorkSize[3] = {  64, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT008x008x08_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 4
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 8
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 8
  LdsNumElements: 409
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 64
  LdsOffsetA_Blk: 128
  GlobalLoadVectorWidthB: 1
  SubGroupA: 4
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 192
  LSCA: 8
  LSCB: 8
  LVPA: 8
  NonTemporalA: 0
  WorkGroup: [4, 4, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 8
  LoopUnroll: 2
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 4
  SubGroup1: 4
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 8
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 64
  LVPB: 8
  LVCA: 8
  MacroTile0: 8
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 64
  LdsOffsetB: 64
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    float * dataC;
    const float * dataA;
    const float * dataB;
    float alpha;
    float beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_ISA803_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 2, 2 };
  const unsigned int groupSize[2] = { 8, 8 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  totalWorkGroups1 *= 16; // GlobalSplitU
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;

  // enqueue Beta-Only kernel
  size_t localWorkSizeBetaOnly[3] = { 8, 8, 1};
  size_t globalWorkSizeBetaOnly[3];
  size_t totalWorkGroupsBetaOnly0 = sizeOfC0 / localWorkSizeBetaOnly[0];
  size_t totalWorkGroupsBetaOnly1 = sizeOfC1 / localWorkSizeBetaOnly[1];
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroupsBetaOnly0*localWorkSizeBetaOnly[0] < sizeOfC0) { totalWorkGroupsBetaOnly0++; }
  if (totalWorkGroupsBetaOnly1*localWorkSizeBetaOnly[1] < sizeOfC1) { totalWorkGroupsBetaOnly1++; }
  globalWorkSizeBetaOnly[0] = totalWorkGroupsBetaOnly0;
  globalWorkSizeBetaOnly[1] = totalWorkGroupsBetaOnly1;
  globalWorkSizeBetaOnly[2] = 1;
  globalWorkSizeBetaOnly[2] *= sizeK;
  bool betaZero = beta == 0;
  if( inputEvents != NULL )
    hipEventRecord(inputEvents[0], stream );
      try {
      if (betaZero) {
        hipLaunchKernelGGL(
          HIP_KERNEL_NAME(Cijk_S),
          dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
          dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
          0, // groupMemBytes
          stream,
          dataC,
          offsetC,
          strideC1J,
          strideC2K,
          sizeI,
          sizeJ,
          sizeK);
          } else {
          hipLaunchKernelGGL(
            HIP_KERNEL_NAME(Cijk_SB),
            dim3(globalWorkSizeBetaOnly[0], globalWorkSizeBetaOnly[1], globalWorkSizeBetaOnly[2]),
            dim3(localWorkSizeBetaOnly[0], localWorkSizeBetaOnly[1], localWorkSizeBetaOnly[2]),
            0, // groupMemBytes
            stream,
            dataC,
            offsetC,
            strideC1J,
            strideC2K,
            sizeI,
            sizeJ,
            sizeK,
            beta);
            }
            } catch (const std::exception& e) {
#ifdef DEBUG
              std::cerr << e.what() << std::endl;
#endif
              return tensileStatusFailure;
            }

            /* kernel 0: Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_ISA900_K1_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01 */
            unsigned int kernelIdx = 0;
            for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
              if( inputEvents != NULL )
                hipEventRecord(inputEvents[enqueueIdx], stream );
              try {
                hipFunctionArgs.dataC = dataC;
                hipFunctionArgs.dataA = dataA;
                hipFunctionArgs.dataB = dataB;
                hipFunctionArgs.alpha = alpha;
                hipFunctionArgs.beta = beta;
                hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.strideC1J = strideC1J;
                hipFunctionArgs.strideC2K = strideC2K;
                hipFunctionArgs.strideA1L = strideA1L;
                hipFunctionArgs.strideA2K = strideA2K;
                hipFunctionArgs.strideB1L = strideB1L;
                hipFunctionArgs.strideB2K = strideB2K;
                hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
                hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
                hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
                hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
                hipModuleLaunchKernel(
                  hipFunction,
                  globalWorkSize[kernelIdx][0],
                  globalWorkSize[kernelIdx][1],
                  globalWorkSize[kernelIdx][2],
                  localWorkSize[0],
                  localWorkSize[1],
                  localWorkSize[2],
                  0, // groupMemBytes
                  stream,
                  NULL,
                  (void**)hipLaunchParams);
              } catch (const std::exception& e) {
#ifdef DEBUG
                std::cerr << e.what() << std::endl;
#endif
                return tensileStatusFailure;
              }
              if( outputEvent != NULL )
                hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_SB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 2
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 8
  DepthU: 16
  GlobalReadCoalesceVectorA: True
  MacroTileB: 16
  LSPB: 16
  PerformanceWaitCount: -1
  ThreadTile0: 2
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 1
  PVA: 2
  MacroTileA: 16
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 8
  ThreadTile1: 2
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 16
  LSCB: 16
  LVPA: 16
  NonTemporalA: 0
  WorkGroup: [8, 8, 4]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_SB
  LocalSplitU: 4
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 1
  GlobalRead2B: True
  WorkGroupMapping: 1
  LVCB: 16
  LoopUnroll: 4
  LSPA: 16
  PrefetchLocalRead: True
  SubGroup0: 8
  SubGroup1: 8
  ThreadTileA: 2
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 16
  GlobalSplitU: 16
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 1
  LdsNumElementsAlignedA: 256
  LVPB: 16
  LVCA: 16
  MacroTile0: 16
  ThreadTile: [2, 2]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_DB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    double * dataC;
    const double * dataA;
    const double * dataB;
    double alpha;
    double beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_DB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_DB_MT064x064x08_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_DB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_DB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bjlk_DB_MT064x064x08_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_DB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 8
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 8
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 1
  MacroTileA: 64
  LdsNumElements: 2048
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 1024
  GlobalLoadVectorWidthB: 2
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 2
  VectorWidth: 2
  PVB: 1
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 1536
  LSCA: 64
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_DB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 32
  LoopUnroll: 8
  LSPA: 8
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 512
  LVPB: 4
  LVCA: 32
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 512
  LdsOffsetB: 512
  NumLoadsPerpendicularB: 1
*/

hipError_t Cijk_Ailk_Bjlk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
  TensileStatus status;

  /* module function args */
  struct {
    double * dataC;
    const double * dataA;
    const double * dataB;
    double alpha;
    double beta;
    unsigned int offsetC;
    unsigned int offsetA;
    unsigned int offsetB;
    unsigned int strideC1J;
    unsigned int strideC2K;
    unsigned int strideA1L;
    unsigned int strideA2K;
    unsigned int strideB1L;
    unsigned int strideB2K;
    unsigned int sizeI;
    unsigned int sizeJ;
    unsigned int sizeK;
    unsigned int sizeL;
    unsigned int pad;
  } hipFunctionArgs;
  size_t hipFunctionArgsSize = sizeof(hipFunctionArgs);
  void *hipLaunchParams[] = {HIP_LAUNCH_PARAM_BUFFER_POINTER, &hipFunctionArgs, HIP_LAUNCH_PARAM_BUFFER_SIZE, &hipFunctionArgsSize, HIP_LAUNCH_PARAM_END};

  /* kernels */
  const unsigned int numKernels = 1; // 1 or 4
  int deviceId;
  hipCtxGetDevice(&deviceId);
  hipDeviceProp_t deviceProperties;
  hipGetDeviceProperties( &deviceProperties, deviceId );
  int isa = deviceProperties.gcnArch;
  hipFunction_t hipFunction;
  if ( isa == 803 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_DB_MT064x064x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_DB_MT064x064x04_GSU01_ISA803_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  }  else if ( isa == 900 ) {
    static hipFunction_t *hipFunctions = nullptr;
    if ( !hipFunctions ) {
      std::mutex initFunctionsMutex;
      std::lock_guard<std::mutex> initFunctionsLock(initFunctionsMutex);
      if ( !hipFunctions ) {
        static int numDevices = -1;
        status = hipGetDeviceCount( &numDevices );
        hipFunctions = new hipFunction_t[numDevices];
        for ( int i = 0; i < numDevices; i++) {
          hipFunctions[i] = nullptr;
        }
      }
    }
    if ( !hipFunctions[deviceId] ) {
      std::mutex loadModuleMutex;
      std::lock_guard<std::mutex> loadModuleLock(loadModuleMutex);
      if (!hipFunctions[deviceId]) {
        hipModule_t module = nullptr;
        hipModuleLoadData(&module, Cijk_Ailk_Bjlk_DB_MT064x064x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08_coba);
        hipModuleGetFunction(&hipFunctions[deviceId], module, "Cijk_Ailk_Bjlk_DB_MT064x064x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08");
      }
    }
    hipFunction = hipFunctions[deviceId];
  } else {
    return tensileStatusFailure;
  }


  /* index assignments */
  const unsigned int indexD0 = 0;
  const unsigned int indexD1 = 1;
  const unsigned int indexDU = 3;

  /* num kernels */
  unsigned int numEnqueues[numKernels] = { 1 };

  /* grid sizes */
  const unsigned int workDim = 3;
  const unsigned int threadTile[2] = { 4, 4 };
  const unsigned int groupSize[2] = { 16, 16 };
  size_t localWorkSize[3] = { 256, 1, 1 };
  size_t globalWorkSize[numKernels][3];
  globalWorkSize[0][2] = 1;
  globalWorkSize[0][2] *= sizeK;
  unsigned int sizeOfC0 = sizeI;
  unsigned int sizeOfC1 = sizeJ;
  unsigned int macroTile0 = static_cast<unsigned int>(groupSize[0] * threadTile[0]);
  unsigned int macroTile1 = static_cast<unsigned int>(groupSize[1] * threadTile[1]);
  unsigned int totalWorkGroups0 = sizeOfC0 / macroTile0;
  unsigned int totalWorkGroups1 = sizeOfC1 / macroTile1;
  // b/c single kernel, add extra work-group here if edge needed
  if (totalWorkGroups0*macroTile0 < sizeOfC0) { totalWorkGroups0++; }
  if (totalWorkGroups1*macroTile1 < sizeOfC1) { totalWorkGroups1++; }
  globalWorkSize[0][0] = totalWorkGroups0;
  globalWorkSize[0][1] = totalWorkGroups1;

  /* offsets */
  unsigned int offsets[numKernels][1][3];
  offsets[0][0][0] = offsetC; // tensorC
  offsets[0][0][1] = offsetA; // tensorA
  offsets[0][0][2] = offsetB; // tensorB

  /* index sizes */
  unsigned int sizes[numKernels][1][4];
  sizes[0][0][0] = sizeI;
  sizes[0][0][1] = sizeJ;
  sizes[0][0][2] = sizeK;
  sizes[0][0][3] = sizeL;


  /* kernel 0: Cijk_Ailk_Bjlk_DB_MT064x064x04_GSU01_ISA900_K1_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08 */
  unsigned int kernelIdx = 0;
  for (unsigned int enqueueIdx = 0; enqueueIdx < numEnqueues[0]; enqueueIdx++) {
    if( inputEvents != NULL )
      hipEventRecord(inputEvents[enqueueIdx], stream );
    try {
      hipFunctionArgs.dataC = dataC;
      hipFunctionArgs.dataA = dataA;
      hipFunctionArgs.dataB = dataB;
      hipFunctionArgs.alpha = alpha;
      hipFunctionArgs.beta = beta;
      hipFunctionArgs.offsetC = offsets[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.offsetA = offsets[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.offsetB = offsets[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.strideC1J = strideC1J;
      hipFunctionArgs.strideC2K = strideC2K;
      hipFunctionArgs.strideA1L = strideA1L;
      hipFunctionArgs.strideA2K = strideA2K;
      hipFunctionArgs.strideB1L = strideB1L;
      hipFunctionArgs.strideB2K = strideB2K;
      hipFunctionArgs.sizeI = sizes[kernelIdx][enqueueIdx][0];
      hipFunctionArgs.sizeJ = sizes[kernelIdx][enqueueIdx][1];
      hipFunctionArgs.sizeK = sizes[kernelIdx][enqueueIdx][2];
      hipFunctionArgs.sizeL = sizes[kernelIdx][enqueueIdx][3];
      hipModuleLaunchKernel(
        hipFunction,
        globalWorkSize[kernelIdx][0],
        globalWorkSize[kernelIdx][1],
        globalWorkSize[kernelIdx][2],
        localWorkSize[0],
        localWorkSize[1],
        localWorkSize[2],
        0, // groupMemBytes
        stream,
        NULL,
        (void**)hipLaunchParams);
    } catch (const std::exception& e) {
#ifdef DEBUG
      std::cerr << e.what() << std::endl;
#endif
      return tensileStatusFailure;
    }
    if( outputEvent != NULL )
      hipEventRecord(outputEvent[enqueueIdx], stream );
  }

  return tensileStatusSuccess;
}

/* Solution Parameters
  ProblemType: Cijk_Ailk_Bjlk_DB
  PrefetchGlobalRead: True
  UnrollMemFence: False
  GlobalRead2A: True
  LoopDoWhile: False
  LocalWrite2A: True
  LocalWrite2B: True
  KernelLanguage: Assembly
  LdsPad: 0
  MaxOccupancy: 40
  ThreadTileB: 4
  MacroTileShapeMax: 64
  Valid: True
  GlobalReadCoalesceVectorB: True
  SubGroupB: 16
  DepthU: 4
  GlobalReadCoalesceVectorA: True
  MacroTileB: 64
  LSPB: 4
  PerformanceWaitCount: -1
  ThreadTile0: 4
  MacroTileShapeMin: 1
  LocalRead2A: True
  LocalRead2B: True
  GlobalWriteVectorWidth: 2
  PVA: 2
  MacroTileA: 64
  LdsNumElements: 1024
  NumLoadsA: 1
  NumLoadsB: 1
  EdgeType: ShiftPtr
  NumThreads: 256
  LdsOffsetA_Blk: 512
  GlobalLoadVectorWidthB: 1
  SubGroupA: 16
  ThreadTile1: 4
  GlobalLoadVectorWidthA: 1
  VectorWidth: 2
  PVB: 2
  GlobalSplitUWorkGroupMappingRoundRobin: False
  PerformanceSyncLocation: -1
  LdsOffsetB_Blk: 768
  LSCA: 64
  LSCB: 64
  LVPA: 4
  NonTemporalA: 0
  WorkGroup: [16, 16, 1]
  NonTemporalC: 0
  NonTemporalB: 0
  LoopTail: True
  ProblemType: Cijk_Ailk_Bjlk_DB
  LocalSplitU: 1
  NumLoadsPerpendicularA: 1
  AssignedProblemIndependentDerivedParameters: True
  NumElementsPerThread: 16
  GlobalRead2B: True
  WorkGroupMapping: 8
  LVCB: 64
  LoopUnroll: 4
  LSPA: 4
  PrefetchLocalRead: True
  SubGroup0: 16
  SubGroup1: 16
  ThreadTileA: 4
  WorkGroupMappingType: B
  PerformanceWaitLocation: -1
  AssignedDerivedParameters: True
  GlobalReadCoalesceGroupB: True
  GlobalReadCoalesceGroupA: True
  MacroTile1: 64
  GlobalSplitU: 1
  LdsOffsetA: 0
  NumLoadsCoalescedA: 1
  NumLoadsCoalescedB: 1
  GlobalSplitUSummationAssignmentRoundRobin: True
  NumGlobalWriteVectorsPerThread: 8
  LdsNumElementsAlignedA: 256
  LVPB: 4
  LVCA: 64
  MacroTile0: 64
  ThreadTile: [4, 4]
  LdsNumElementsAlignedB: 256
  LdsOffsetB: 256
  NumLoadsPerpendicularB: 1
*/

