#include "Tensile.h"
#include "TensileInternal.h"
#include "Solutions.h"
/*******************************************************************************
 * Per-Schedule Functions
 *******************************************************************************/
// problem size -> solution logic
TensileSolutionPointer_Cijk_Alik_Bljk_SB tensileGetSolutionPointerUncached_Tensile_Cijk_Alik_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */
  if ( sizeI == 8448 && sizeJ == 48000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08; // 8925 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 7000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01; // 7133 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 64 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08; // 4505 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 128 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08; // 5505 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 64 && sizeK == 1 && sizeL == 4096 ) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08; // 3429 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01; // 7542 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08; // 8538 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01; // 8420 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 32 && sizeK == 1 && sizeL == 2048 ) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08; // 1675 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 48000 && sizeK == 1 && sizeL == 1024 ) return Cijk_Alik_Bljk_SB_MT096x128x16_GSU01_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01; // 7871 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 4096 ) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01; // 8099 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 1760 ) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08; // 9821 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 32 && sizeK == 1 && sizeL == 4096 ) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01; // 2588 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01; // 8429 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 64 && sizeK == 1 && sizeL == 1760 ) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08; // 3635 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01; // 7886 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 128 && sizeK == 1 && sizeL == 4096 ) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08; // 4592 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 24000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01; // 8370 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01; // 8362 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 16 && sizeK == 1 && sizeL == 2816 ) return Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01; // 2002 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 16 && sizeK == 1 && sizeL == 1536 ) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01; // 1368 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01; // 8509 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 24000 && sizeK == 1 && sizeL == 1024 ) return Cijk_Alik_Bljk_SB_MT096x128x16_GSU01_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01; // 7753 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 64 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08; // 3421 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 16 && sizeK == 1 && sizeL == 500000 ) return Cijk_Alik_Bljk_SB_MT064x016x64_GSU32_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01; // 2960 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 16 && sizeK == 1 && sizeL == 1024 ) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08; // 708 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 128 && sizeK == 1 && sizeL == 1024 ) return Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08; // 2452 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 7000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08; // 8303 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 24000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08; // 9271 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01; // 7848 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 64 && sizeK == 1 && sizeL == 2048 ) return Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08; // 2230 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08; // 8933 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 128 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08; // 4470 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 16 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01; // 1317 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01; // 8260 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01; // 7528 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 7000 && sizeK == 1 && sizeL == 1760 ) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08; // 9151 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 16 && sizeK == 1 && sizeL == 4096 ) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08; // 1384 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08; // 8251 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 2048 ) return Cijk_Alik_Bljk_SB_MT048x048x16_GSU08_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01; // 2980 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 32 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01; // 3002 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 32 && sizeK == 1 && sizeL == 2816 ) return Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01; // 3671 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 8 && sizeK == 1 && sizeL == 500000 ) return Cijk_Alik_Bljk_SB_MT064x016x64_GSU32_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01; // 1494 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 16 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01; // 1730 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01; // 8254 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 16 && sizeK == 1 && sizeL == 1760 ) return Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01; // 1580 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 2048 ) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08; // 8020 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 1760 ) return Cijk_Alik_Bljk_SB_MT036x048x16_GSU02_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01; // 3736 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 700 && sizeK == 1 && sizeL == 512 ) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08; // 3013 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 32 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08; // 2309 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 32 && sizeK == 1 && sizeL == 1760 ) return Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01; // 2655 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 16 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01; // 1683 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08; // 8578 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 7000 && sizeK == 1 && sizeL == 4096 ) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01; // 7932 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 32 && sizeK == 1 && sizeL == 1024 ) return Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08; // 1403 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 32 && sizeK == 1 && sizeL == 1536 ) return Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08; // 2361 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT036x048x16_GSU08_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01; // 3319 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 48000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01; // 8685 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01; // 9271 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 64 && sizeK == 1 && sizeL == 1024 ) return Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08; // 2125 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08; // 9116 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 16 && sizeK == 1 && sizeL == 2048 ) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08; // 895 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01; // 7932 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01; // 8222 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 128 && sizeK == 1 && sizeL == 1760 ) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08; // 4952 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 128 && sizeK == 1 && sizeL == 2048 ) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08; // 2787 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 4096 ) return Cijk_Alik_Bljk_SB_MT036x048x16_GSU08_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01; // 3516 GFlop/s
  else if ( sizeI == 512 && sizeJ == 8 && sizeK == 1 && sizeL == 500000 ) return Cijk_Alik_Bljk_SB_MT064x008x64_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_02_08_WGM01; // 1503 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08; // 8188 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 32 && sizeK == 1 && sizeL == 2560 ) return Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01; // 3135 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01; // 7822 GFlop/s
  else if ( sizeI == 512 && sizeJ == 16 && sizeK == 1 && sizeL == 500000 ) return Cijk_Alik_Bljk_SB_MT064x016x64_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01; // 2841 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01; // 9049 GFlop/s

  /* range mappings */
  {
    {
      if (sizeI <= 4) {
        return Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
      }
      if (sizeI <= 64) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 256) return Cijk_Alik_Bljk_SB_MT032x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 448) return Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 704) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01;
        if (sizeJ <= 1024) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08;
        if (sizeJ <= 1408) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 1856) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 2368) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08;
        if (sizeJ <= 2944) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 3584) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 4288) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 5888) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 128) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT032x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 256) return Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 448) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01;
        if (sizeJ <= 704) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 1024) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 1408) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 1856) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01;
        if (sizeJ <= 2944) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 3584) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 4288) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 5056) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5888) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 256) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Alik_Bljk_SB_MT064x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 256) return Cijk_Alik_Bljk_SB_MT064x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01;
        if (sizeJ <= 448) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 2944) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 3584) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 4288) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5056) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5888) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 448) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01;
        if (sizeJ <= 448) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08;
        if (sizeJ <= 704) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1024) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1856) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2944) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 3584) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 4288) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5056) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5888) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 704) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT008x008x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01;
        if (sizeJ <= 64) return Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 448) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1024) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1408) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 3584) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 4288) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5888) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 1024) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT032x032x08_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01;
        if (sizeJ <= 256) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1024) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1856) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2368) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2944) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 3584) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 4288) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 1408) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01;
        if (sizeJ <= 64) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08;
        if (sizeJ <= 448) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1024) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 3584) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 4288) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
        return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 1856) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01;
        if (sizeJ <= 64) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1024) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 2368) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08;
        if (sizeJ <= 448) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 704) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1024) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1856) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 2944) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1408) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 3584) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1024) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 4288) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1024) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 5056) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 448) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 5888) {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 256) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      {
        if (sizeJ <= 4) return Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 256) return Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        return Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
    }
  }

}

// get solution name for problem size
const char * tensileGetSolutionName_Tensile_Cijk_Alik_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */
  if ( sizeI == 8448 && sizeJ == 48000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08~"; // 8925 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 7000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01~"; // 7133 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 64 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08~"; // 4505 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 128 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08~"; // 5505 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 64 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08~"; // 3429 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01~"; // 7542 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08~"; // 8538 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01~"; // 8420 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 32 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08~"; // 1675 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 48000 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Alik_Bljk_SB_MT096x128x16_GSU01_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01~"; // 7871 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01~"; // 8099 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08~"; // 9821 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 32 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01~"; // 2588 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01~"; // 8429 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 64 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08~"; // 3635 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01~"; // 7886 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 128 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08~"; // 4592 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 24000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01~"; // 8370 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01~"; // 8362 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 16 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01~"; // 2002 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 16 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01~"; // 1368 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01~"; // 8509 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 24000 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Alik_Bljk_SB_MT096x128x16_GSU01_NLCA01_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM01~"; // 7753 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 64 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08~"; // 3421 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 16 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Alik_Bljk_SB_MT064x016x64_GSU32_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01~"; // 2960 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 16 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08~"; // 708 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 128 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08~"; // 2452 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 7000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08~"; // 8303 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 24000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08~"; // 9271 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01~"; // 7848 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 64 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08~"; // 2230 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08~"; // 8933 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 128 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08~"; // 4470 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 16 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01~"; // 1317 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01~"; // 8260 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01~"; // 7528 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 7000 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08~"; // 9151 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 16 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08~"; // 1384 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08~"; // 8251 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Alik_Bljk_SB_MT048x048x16_GSU08_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01~"; // 2980 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 32 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01~"; // 3002 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 32 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01~"; // 3671 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 8 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Alik_Bljk_SB_MT064x016x64_GSU32_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01~"; // 1494 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 16 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01~"; // 1730 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01~"; // 8254 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 16 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01~"; // 1580 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08~"; // 8020 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Alik_Bljk_SB_MT036x048x16_GSU02_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01~"; // 3736 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 700 && sizeK == 1 && sizeL == 512 ) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08~"; // 3013 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 32 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08~"; // 2309 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 32 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01~"; // 2655 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 16 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01~"; // 1683 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08~"; // 8578 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 7000 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01~"; // 7932 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 32 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08~"; // 1403 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 32 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08~"; // 2361 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT036x048x16_GSU08_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01~"; // 3319 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 48000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01~"; // 8685 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01~"; // 9271 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 64 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Alik_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08~"; // 2125 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08~"; // 9116 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 16 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08~"; // 895 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01~"; // 7932 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01~"; // 8222 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 128 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08~"; // 4952 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 128 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08~"; // 2787 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Alik_Bljk_SB_MT036x048x16_GSU08_NLCA01_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01~"; // 3516 GFlop/s
  else if ( sizeI == 512 && sizeJ == 8 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Alik_Bljk_SB_MT064x008x64_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_02_08_WGM01~"; // 1503 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08~"; // 8188 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 32 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01~"; // 3135 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01~"; // 7822 GFlop/s
  else if ( sizeI == 512 && sizeJ == 16 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Alik_Bljk_SB_MT064x016x64_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01~"; // 2841 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01~"; // 9049 GFlop/s

  /* range mappings */
  {
    {
      if (sizeI <= 4) {
        return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
      }
      if (sizeI <= 64) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 256) return "Cijk_Alik_Bljk_SB_MT032x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 448) return "Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 704) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01";
        if (sizeJ <= 1024) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08";
        if (sizeJ <= 1408) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 1856) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 2368) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08";
        if (sizeJ <= 2944) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 3584) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 4288) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 5888) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 128) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Alik_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT032x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 256) return "Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 448) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01";
        if (sizeJ <= 704) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 1024) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 1408) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 1856) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01";
        if (sizeJ <= 2944) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 3584) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 4288) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 5056) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5888) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 256) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Alik_Bljk_SB_MT064x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 256) return "Cijk_Alik_Bljk_SB_MT064x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01";
        if (sizeJ <= 448) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 2944) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 3584) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 4288) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5056) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5888) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 448) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01";
        if (sizeJ <= 448) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08";
        if (sizeJ <= 704) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1024) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1856) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2944) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 3584) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 4288) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5056) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5888) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 704) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT008x008x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Alik_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 448) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1024) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1408) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 3584) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 4288) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5888) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 1024) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Alik_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT032x032x08_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01";
        if (sizeJ <= 256) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1024) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1856) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2368) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2944) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 3584) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 4288) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 1408) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01";
        if (sizeJ <= 64) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08";
        if (sizeJ <= 448) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1024) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 3584) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 4288) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
        return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 1856) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01";
        if (sizeJ <= 64) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1024) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 2368) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08";
        if (sizeJ <= 448) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 704) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1024) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1856) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 2944) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1408) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 3584) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1024) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 4288) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1024) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 5056) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 448) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 5888) {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 256) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      {
        if (sizeJ <= 4) return "Cijk_Alik_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Alik_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Alik_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 256) return "Cijk_Alik_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Alik_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Alik_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
    }
  }

}
/*******************************************************************************
 * Per-ProblemType Functions
 *******************************************************************************/
// return solution PointerUncached
TensileSolutionPointer_Cijk_Alik_Bljk_SB tensileGetSolutionPointerUncached_Cijk_Alik_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionPointerUncached_Tensile_Cijk_Alik_Bljk_SB(strideC1J, strideC2K, strideA1I, strideA2K, strideB1J, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution Name
const char *tensileGetSolutionName_Cijk_Alik_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionName_Tensile_Cijk_Alik_Bljk_SB(strideC1J, strideC2K, strideA1I, strideA2K, strideB1J, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution pointer; user calls it
Map_Cijk_Alik_Bljk_SB solutionMap_Cijk_Alik_Bljk_SB;
TensileSolutionPointer_Cijk_Alik_Bljk_SB tensileGetSolutionPointer_Cijk_Alik_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  ProblemSizeKey key = std::make_tuple( sizeI, sizeJ, sizeL );
  Map_Cijk_Alik_Bljk_SB::iterator iter = solutionMap_Cijk_Alik_Bljk_SB.find(key);
  if (iter != solutionMap_Cijk_Alik_Bljk_SB.end()) {
    return iter->second;
  } else {
    TensileSolutionPointer_Cijk_Alik_Bljk_SB ptr = tensileGetSolutionPointerUncached_Cijk_Alik_Bljk_SB(
        strideC1J,
        strideC2K,
        strideA1I,
        strideA2K,
        strideB1J,
        strideB2K,
        sizeI,
        sizeJ,
        sizeK,
        sizeL,
        stream);
    solutionMap_Cijk_Alik_Bljk_SB[key] = ptr;
    return ptr;
  }
}

// main call to solution; enqueues a kernel
TensileStatus tensile_Cijk_Alik_Bljk_SB(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
    TensileSolutionPointer_Cijk_Alik_Bljk_SB ptr = tensileGetSolutionPointer_Cijk_Alik_Bljk_SB(
        strideC1J, 
        strideC2K, 
        strideA1I, 
        strideA2K, 
        strideB1J, 
        strideB2K, 
        sizeI, 
        sizeJ, 
        sizeK, 
        sizeL, 
        stream);
    if ( ptr ) {
      return ptr(dataC, dataA, dataB, alpha, beta, offsetC, offsetA, offsetB, strideC1J, strideC2K, strideA1I, strideA2K, strideB1J, strideB2K, sizeI, sizeJ, sizeK, sizeL, stream, numInputEvents, inputEvents, outputEvent);
    } else {
      return tensileStatusFailure; // no solution found
    }
}
/*******************************************************************************
 * Per-Schedule Functions
 *******************************************************************************/
// problem size -> solution logic
TensileSolutionPointer_Cijk_Ailk_Bljk_DB tensileGetSolutionPointerUncached_Tensile_Cijk_Ailk_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */

  /* range mappings */
  {
    {
      if (sizeI <= 1) {
        return Cijk_Ailk_Bljk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08;
      }
      {
        if (sizeJ <= 1) return Cijk_Ailk_Bljk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08;
        return Cijk_Ailk_Bljk_DB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08;
      }
    }
  }

}

// get solution name for problem size
const char * tensileGetSolutionName_Tensile_Cijk_Ailk_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */

  /* range mappings */
  {
    {
      if (sizeI <= 1) {
        return "Cijk_Ailk_Bljk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08";
      }
      {
        if (sizeJ <= 1) return "Cijk_Ailk_Bljk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bljk_DB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08";
      }
    }
  }

}
/*******************************************************************************
 * Per-ProblemType Functions
 *******************************************************************************/
// return solution PointerUncached
TensileSolutionPointer_Cijk_Ailk_Bljk_DB tensileGetSolutionPointerUncached_Cijk_Ailk_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionPointerUncached_Tensile_Cijk_Ailk_Bljk_DB(strideC1J, strideC2K, strideA1L, strideA2K, strideB1J, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution Name
const char *tensileGetSolutionName_Cijk_Ailk_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionName_Tensile_Cijk_Ailk_Bljk_DB(strideC1J, strideC2K, strideA1L, strideA2K, strideB1J, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution pointer; user calls it
Map_Cijk_Ailk_Bljk_DB solutionMap_Cijk_Ailk_Bljk_DB;
TensileSolutionPointer_Cijk_Ailk_Bljk_DB tensileGetSolutionPointer_Cijk_Ailk_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  ProblemSizeKey key = std::make_tuple( sizeI, sizeJ, sizeL );
  Map_Cijk_Ailk_Bljk_DB::iterator iter = solutionMap_Cijk_Ailk_Bljk_DB.find(key);
  if (iter != solutionMap_Cijk_Ailk_Bljk_DB.end()) {
    return iter->second;
  } else {
    TensileSolutionPointer_Cijk_Ailk_Bljk_DB ptr = tensileGetSolutionPointerUncached_Cijk_Ailk_Bljk_DB(
        strideC1J,
        strideC2K,
        strideA1L,
        strideA2K,
        strideB1J,
        strideB2K,
        sizeI,
        sizeJ,
        sizeK,
        sizeL,
        stream);
    solutionMap_Cijk_Ailk_Bljk_DB[key] = ptr;
    return ptr;
  }
}

// main call to solution; enqueues a kernel
TensileStatus tensile_Cijk_Ailk_Bljk_DB(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
    TensileSolutionPointer_Cijk_Ailk_Bljk_DB ptr = tensileGetSolutionPointer_Cijk_Ailk_Bljk_DB(
        strideC1J, 
        strideC2K, 
        strideA1L, 
        strideA2K, 
        strideB1J, 
        strideB2K, 
        sizeI, 
        sizeJ, 
        sizeK, 
        sizeL, 
        stream);
    if ( ptr ) {
      return ptr(dataC, dataA, dataB, alpha, beta, offsetC, offsetA, offsetB, strideC1J, strideC2K, strideA1L, strideA2K, strideB1J, strideB2K, sizeI, sizeJ, sizeK, sizeL, stream, numInputEvents, inputEvents, outputEvent);
    } else {
      return tensileStatusFailure; // no solution found
    }
}
/*******************************************************************************
 * Per-Schedule Functions
 *******************************************************************************/
// problem size -> solution logic
TensileSolutionPointer_Cijk_Ailk_Bjlk_SB tensileGetSolutionPointerUncached_Tensile_Cijk_Ailk_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */
  if ( sizeI == 4096 && sizeJ == 7133 && sizeK == 1 && sizeL == 4096 ) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01; // 11060 GFlop/s
  else if ( sizeI == 512 && sizeJ == 16 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01; // 333 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 7133 && sizeK == 1 && sizeL == 1760 ) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08; // 9878 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 7133 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01; // 10578 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 32 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01; // 1108 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 7435 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01; // 9803 GFlop/s
  else if ( sizeI == 512 && sizeJ == 32 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01; // 631 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 7133 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01; // 10566 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 5481 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08; // 10861 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 16 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01; // 593 GFlop/s

  /* range mappings */
  {
    {
      if (sizeI <= 4) {
        return Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01;
      }
      if (sizeI <= 64) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT032x008x32_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 448) return Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 1024) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 1408) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 1856) return Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 2368) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 2944) return Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 4288) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 5888) return Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        return Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
      }
      if (sizeI <= 128) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bjlk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 256) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 1024) return Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 1408) return Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 1856) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 2944) return Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 3584) return Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 4288) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 5056) return Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 5888) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 256) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01;
        if (sizeJ <= 448) return Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2944) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 3584) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5056) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5888) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 448) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 256) return Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1856) return Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2944) return Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5056) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5888) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 704) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1024) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1856) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5888) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 1024) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1408) return Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2368) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2944) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 3584) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 4288) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5056) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
        return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 1408) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1024) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2368) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5888) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 1856) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 448) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1024) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2368) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2944) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 3584) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 4288) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5056) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5888) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 2368) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1024) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2944) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 3584) return Cijk_Ailk_Bjlk_SB_MT096x128x16_GSU01_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08;
        if (sizeJ <= 4288) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 2944) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2368) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2944) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 3584) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 3584) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 448) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1024) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2368) return Cijk_Ailk_Bjlk_SB_MT128x096x16_GSU01_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGM01;
        if (sizeJ <= 2944) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5888) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 4288) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1024) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2368) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2944) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 3584) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5056) return Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 5056) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1408) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 3584) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 4288) return Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 5888) {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 448) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2944) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
        return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
      {
        if (sizeJ <= 4) return Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1024) return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
      }
    }
  }

}

// get solution name for problem size
const char * tensileGetSolutionName_Tensile_Cijk_Ailk_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */
  if ( sizeI == 4096 && sizeJ == 7133 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01~"; // 11060 GFlop/s
  else if ( sizeI == 512 && sizeJ == 16 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01~"; // 333 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 7133 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08~"; // 9878 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 7133 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01~"; // 10578 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 32 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01~"; // 1108 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 7435 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01~"; // 9803 GFlop/s
  else if ( sizeI == 512 && sizeJ == 32 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01~"; // 631 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 7133 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01~"; // 10566 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 5481 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08~"; // 10861 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 16 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01~"; // 593 GFlop/s

  /* range mappings */
  {
    {
      if (sizeI <= 4) {
        return "Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01";
      }
      if (sizeI <= 64) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bjlk_SB_MT016x016x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT032x008x32_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 448) return "Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        return "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
      }
      if (sizeI <= 128) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bjlk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT032x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 256) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 256) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bjlk_SB_MT064x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01";
        if (sizeJ <= 448) return "Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 448) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 256) return "Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 704) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 1024) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
        return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 1408) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 1856) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 448) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 2368) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bjlk_SB_MT096x128x16_GSU01_NLCA03_NLCB01_PGR1_TT06_08_VW02_WG16_16_01_WGM08";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 2944) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 3584) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 448) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bjlk_SB_MT128x096x16_GSU01_NLCA01_NLCB03_PGR1_TT08_06_VW02_WG16_16_01_WGM01";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 4288) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 5056) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 5888) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x04_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 448) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
        return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
      {
        if (sizeJ <= 4) return "Cijk_Ailk_Bjlk_SB_MT016x016x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bjlk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bjlk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
      }
    }
  }

}
/*******************************************************************************
 * Per-ProblemType Functions
 *******************************************************************************/
// return solution PointerUncached
TensileSolutionPointer_Cijk_Ailk_Bjlk_SB tensileGetSolutionPointerUncached_Cijk_Ailk_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionPointerUncached_Tensile_Cijk_Ailk_Bjlk_SB(strideC1J, strideC2K, strideA1L, strideA2K, strideB1L, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution Name
const char *tensileGetSolutionName_Cijk_Ailk_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionName_Tensile_Cijk_Ailk_Bjlk_SB(strideC1J, strideC2K, strideA1L, strideA2K, strideB1L, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution pointer; user calls it
Map_Cijk_Ailk_Bjlk_SB solutionMap_Cijk_Ailk_Bjlk_SB;
TensileSolutionPointer_Cijk_Ailk_Bjlk_SB tensileGetSolutionPointer_Cijk_Ailk_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  ProblemSizeKey key = std::make_tuple( sizeI, sizeJ, sizeL );
  Map_Cijk_Ailk_Bjlk_SB::iterator iter = solutionMap_Cijk_Ailk_Bjlk_SB.find(key);
  if (iter != solutionMap_Cijk_Ailk_Bjlk_SB.end()) {
    return iter->second;
  } else {
    TensileSolutionPointer_Cijk_Ailk_Bjlk_SB ptr = tensileGetSolutionPointerUncached_Cijk_Ailk_Bjlk_SB(
        strideC1J,
        strideC2K,
        strideA1L,
        strideA2K,
        strideB1L,
        strideB2K,
        sizeI,
        sizeJ,
        sizeK,
        sizeL,
        stream);
    solutionMap_Cijk_Ailk_Bjlk_SB[key] = ptr;
    return ptr;
  }
}

// main call to solution; enqueues a kernel
TensileStatus tensile_Cijk_Ailk_Bjlk_SB(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
    TensileSolutionPointer_Cijk_Ailk_Bjlk_SB ptr = tensileGetSolutionPointer_Cijk_Ailk_Bjlk_SB(
        strideC1J, 
        strideC2K, 
        strideA1L, 
        strideA2K, 
        strideB1L, 
        strideB2K, 
        sizeI, 
        sizeJ, 
        sizeK, 
        sizeL, 
        stream);
    if ( ptr ) {
      return ptr(dataC, dataA, dataB, alpha, beta, offsetC, offsetA, offsetB, strideC1J, strideC2K, strideA1L, strideA2K, strideB1L, strideB2K, sizeI, sizeJ, sizeK, sizeL, stream, numInputEvents, inputEvents, outputEvent);
    } else {
      return tensileStatusFailure; // no solution found
    }
}
/*******************************************************************************
 * Per-Schedule Functions
 *******************************************************************************/
// problem size -> solution logic
TensileSolutionPointer_Cijk_Ailk_Bjlk_DB tensileGetSolutionPointerUncached_Tensile_Cijk_Ailk_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */

  /* range mappings */
  {
    {
      if (sizeI <= 1) {
        return Cijk_Ailk_Bjlk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08;
      }
      {
        if (sizeJ <= 1) return Cijk_Ailk_Bjlk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08;
        return Cijk_Ailk_Bjlk_DB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08;
      }
    }
  }

}

// get solution name for problem size
const char * tensileGetSolutionName_Tensile_Cijk_Ailk_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */

  /* range mappings */
  {
    {
      if (sizeI <= 1) {
        return "Cijk_Ailk_Bjlk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08";
      }
      {
        if (sizeJ <= 1) return "Cijk_Ailk_Bjlk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bjlk_DB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08";
      }
    }
  }

}
/*******************************************************************************
 * Per-ProblemType Functions
 *******************************************************************************/
// return solution PointerUncached
TensileSolutionPointer_Cijk_Ailk_Bjlk_DB tensileGetSolutionPointerUncached_Cijk_Ailk_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionPointerUncached_Tensile_Cijk_Ailk_Bjlk_DB(strideC1J, strideC2K, strideA1L, strideA2K, strideB1L, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution Name
const char *tensileGetSolutionName_Cijk_Ailk_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionName_Tensile_Cijk_Ailk_Bjlk_DB(strideC1J, strideC2K, strideA1L, strideA2K, strideB1L, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution pointer; user calls it
Map_Cijk_Ailk_Bjlk_DB solutionMap_Cijk_Ailk_Bjlk_DB;
TensileSolutionPointer_Cijk_Ailk_Bjlk_DB tensileGetSolutionPointer_Cijk_Ailk_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  ProblemSizeKey key = std::make_tuple( sizeI, sizeJ, sizeL );
  Map_Cijk_Ailk_Bjlk_DB::iterator iter = solutionMap_Cijk_Ailk_Bjlk_DB.find(key);
  if (iter != solutionMap_Cijk_Ailk_Bjlk_DB.end()) {
    return iter->second;
  } else {
    TensileSolutionPointer_Cijk_Ailk_Bjlk_DB ptr = tensileGetSolutionPointerUncached_Cijk_Ailk_Bjlk_DB(
        strideC1J,
        strideC2K,
        strideA1L,
        strideA2K,
        strideB1L,
        strideB2K,
        sizeI,
        sizeJ,
        sizeK,
        sizeL,
        stream);
    solutionMap_Cijk_Ailk_Bjlk_DB[key] = ptr;
    return ptr;
  }
}

// main call to solution; enqueues a kernel
TensileStatus tensile_Cijk_Ailk_Bjlk_DB(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
    TensileSolutionPointer_Cijk_Ailk_Bjlk_DB ptr = tensileGetSolutionPointer_Cijk_Ailk_Bjlk_DB(
        strideC1J, 
        strideC2K, 
        strideA1L, 
        strideA2K, 
        strideB1L, 
        strideB2K, 
        sizeI, 
        sizeJ, 
        sizeK, 
        sizeL, 
        stream);
    if ( ptr ) {
      return ptr(dataC, dataA, dataB, alpha, beta, offsetC, offsetA, offsetB, strideC1J, strideC2K, strideA1L, strideA2K, strideB1L, strideB2K, sizeI, sizeJ, sizeK, sizeL, stream, numInputEvents, inputEvents, outputEvent);
    } else {
      return tensileStatusFailure; // no solution found
    }
}
/*******************************************************************************
 * Per-Schedule Functions
 *******************************************************************************/
// problem size -> solution logic
TensileSolutionPointer_Cijk_Alik_Bjlk_DB tensileGetSolutionPointerUncached_Tensile_Cijk_Alik_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */

  /* range mappings */
  {
    {
      if (sizeI <= 1) {
        return Cijk_Alik_Bjlk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08;
      }
      {
        if (sizeJ <= 1) return Cijk_Alik_Bjlk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08;
        return Cijk_Alik_Bjlk_DB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08;
      }
    }
  }

}

// get solution name for problem size
const char * tensileGetSolutionName_Tensile_Cijk_Alik_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */

  /* range mappings */
  {
    {
      if (sizeI <= 1) {
        return "Cijk_Alik_Bjlk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08";
      }
      {
        if (sizeJ <= 1) return "Cijk_Alik_Bjlk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08";
        return "Cijk_Alik_Bjlk_DB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08";
      }
    }
  }

}
/*******************************************************************************
 * Per-ProblemType Functions
 *******************************************************************************/
// return solution PointerUncached
TensileSolutionPointer_Cijk_Alik_Bjlk_DB tensileGetSolutionPointerUncached_Cijk_Alik_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionPointerUncached_Tensile_Cijk_Alik_Bjlk_DB(strideC1J, strideC2K, strideA1I, strideA2K, strideB1L, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution Name
const char *tensileGetSolutionName_Cijk_Alik_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionName_Tensile_Cijk_Alik_Bjlk_DB(strideC1J, strideC2K, strideA1I, strideA2K, strideB1L, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution pointer; user calls it
Map_Cijk_Alik_Bjlk_DB solutionMap_Cijk_Alik_Bjlk_DB;
TensileSolutionPointer_Cijk_Alik_Bjlk_DB tensileGetSolutionPointer_Cijk_Alik_Bjlk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  ProblemSizeKey key = std::make_tuple( sizeI, sizeJ, sizeL );
  Map_Cijk_Alik_Bjlk_DB::iterator iter = solutionMap_Cijk_Alik_Bjlk_DB.find(key);
  if (iter != solutionMap_Cijk_Alik_Bjlk_DB.end()) {
    return iter->second;
  } else {
    TensileSolutionPointer_Cijk_Alik_Bjlk_DB ptr = tensileGetSolutionPointerUncached_Cijk_Alik_Bjlk_DB(
        strideC1J,
        strideC2K,
        strideA1I,
        strideA2K,
        strideB1L,
        strideB2K,
        sizeI,
        sizeJ,
        sizeK,
        sizeL,
        stream);
    solutionMap_Cijk_Alik_Bjlk_DB[key] = ptr;
    return ptr;
  }
}

// main call to solution; enqueues a kernel
TensileStatus tensile_Cijk_Alik_Bjlk_DB(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
    TensileSolutionPointer_Cijk_Alik_Bjlk_DB ptr = tensileGetSolutionPointer_Cijk_Alik_Bjlk_DB(
        strideC1J, 
        strideC2K, 
        strideA1I, 
        strideA2K, 
        strideB1L, 
        strideB2K, 
        sizeI, 
        sizeJ, 
        sizeK, 
        sizeL, 
        stream);
    if ( ptr ) {
      return ptr(dataC, dataA, dataB, alpha, beta, offsetC, offsetA, offsetB, strideC1J, strideC2K, strideA1I, strideA2K, strideB1L, strideB2K, sizeI, sizeJ, sizeK, sizeL, stream, numInputEvents, inputEvents, outputEvent);
    } else {
      return tensileStatusFailure; // no solution found
    }
}
/*******************************************************************************
 * Per-Schedule Functions
 *******************************************************************************/
// problem size -> solution logic
TensileSolutionPointer_Cijk_Alik_Bjlk_SB tensileGetSolutionPointerUncached_Tensile_Cijk_Alik_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */

  /* range mappings */
  {
    {
      if (sizeI <= 4) {
        return Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1;
      }
      if (sizeI <= 64) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT008x008x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1;
        if (sizeJ <= 64) return Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1;
        if (sizeJ <= 256) return Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1;
        if (sizeJ <= 448) return Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1;
        if (sizeJ <= 704) return Cijk_Alik_Bjlk_SB_MT016x064x16_GSU04_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1;
        if (sizeJ <= 1024) return Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1;
        if (sizeJ <= 1408) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 2368) return Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4;
        if (sizeJ <= 2944) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1;
        if (sizeJ <= 3584) return Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4;
        if (sizeJ <= 4288) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 5056) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 5888) return Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4;
        return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
      }
      if (sizeI <= 128) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1;
        if (sizeJ <= 64) return Cijk_Alik_Bjlk_SB_MT008x032x32_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1;
        if (sizeJ <= 256) return Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1;
        if (sizeJ <= 448) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1;
        if (sizeJ <= 704) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 1024) return Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4;
        if (sizeJ <= 2944) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 3584) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 5056) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 5888) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
      }
      if (sizeI <= 256) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1;
        if (sizeJ <= 64) return Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1;
        if (sizeJ <= 256) return Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4;
        if (sizeJ <= 448) return Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4;
        if (sizeJ <= 1024) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 2944) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 3584) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 5056) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 5888) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
      }
      if (sizeI <= 448) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1;
        if (sizeJ <= 64) return Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4;
        if (sizeJ <= 256) return Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4;
        if (sizeJ <= 448) return Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1;
        if (sizeJ <= 704) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1024) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 1408) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1856) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 2368) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 2944) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 3584) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 4288) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 5056) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 5888) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
      }
      if (sizeI <= 704) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT008x008x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1;
        if (sizeJ <= 64) return Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 448) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 704) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 1024) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1408) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 1856) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 2368) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 2944) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 5888) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4;
      }
      if (sizeI <= 1024) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1;
        if (sizeJ <= 64) return Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 256) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 704) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 1408) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 1856) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 2368) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 2944) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 3584) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 4288) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4;
      }
      if (sizeI <= 1408) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT008x008x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1;
        if (sizeJ <= 64) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 704) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1408) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 2368) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 4288) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 5056) return Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 5888) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4;
        return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
      }
      if (sizeI <= 1856) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1;
        if (sizeJ <= 64) return Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 256) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 448) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 704) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1856) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 2368) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 3584) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 4288) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 5888) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1;
        return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
      }
      if (sizeI <= 2368) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1;
        if (sizeJ <= 64) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1;
        if (sizeJ <= 256) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 448) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 704) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 1024) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 1856) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 2368) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 2944) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 4288) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 5056) return Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1;
        return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
      }
      if (sizeI <= 2944) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1;
        if (sizeJ <= 64) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 256) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 448) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 704) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1024) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 1408) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1856) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 2368) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 5056) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        return Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1;
      }
      if (sizeI <= 3584) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 256) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 448) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 704) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 1024) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 1856) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 2944) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4;
      }
      if (sizeI <= 4288) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1;
        if (sizeJ <= 64) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 256) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 448) return Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 704) return Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1024) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 1856) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 2368) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 3584) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 4288) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 5056) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
        return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4;
      }
      if (sizeI <= 5056) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1;
        if (sizeJ <= 256) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 448) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 704) return Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1408) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1856) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 3584) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 5056) return Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 5888) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4;
        return Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1;
      }
      if (sizeI <= 5888) {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1;
        if (sizeJ <= 64) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 256) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 704) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1408) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1856) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 2368) return Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 2944) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 3584) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 4288) return Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 5056) return Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4;
        return Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1;
      }
      {
        if (sizeJ <= 4) return Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1;
        if (sizeJ <= 64) return Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1;
        if (sizeJ <= 128) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 256) return Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 448) return Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1024) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 1408) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4;
        if (sizeJ <= 1856) return Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 2368) return Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1;
        if (sizeJ <= 3584) return Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4;
        return Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1;
      }
    }
  }

}

// get solution name for problem size
const char * tensileGetSolutionName_Tensile_Cijk_Alik_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */

  /* range mappings */
  {
    {
      if (sizeI <= 4) {
        return "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1";
      }
      if (sizeI <= 64) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT008x008x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1";
        if (sizeJ <= 64) return "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_16_02_WGMn1";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT008x032x16_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1";
        if (sizeJ <= 256) return "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1";
        if (sizeJ <= 448) return "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1";
        if (sizeJ <= 704) return "Cijk_Alik_Bjlk_SB_MT016x064x16_GSU04_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1";
        if (sizeJ <= 1024) return "Cijk_Alik_Bjlk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_04_WGMn1";
        if (sizeJ <= 1408) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 2368) return "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4";
        if (sizeJ <= 2944) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1";
        if (sizeJ <= 3584) return "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4";
        if (sizeJ <= 4288) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 5056) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 5888) return "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4";
        return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
      }
      if (sizeI <= 128) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1";
        if (sizeJ <= 64) return "Cijk_Alik_Bjlk_SB_MT008x032x32_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG04_08_04_WGMn1";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1";
        if (sizeJ <= 256) return "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1";
        if (sizeJ <= 448) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1";
        if (sizeJ <= 704) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 1024) return "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4";
        if (sizeJ <= 2944) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 3584) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 5056) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 5888) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
      }
      if (sizeI <= 256) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1";
        if (sizeJ <= 64) return "Cijk_Alik_Bjlk_SB_MT016x064x16_GSU08_NLCA01_NLCB01_PGR1_TT02_04_VW02_WG08_16_02_WGMn1";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1";
        if (sizeJ <= 256) return "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4";
        if (sizeJ <= 448) return "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4";
        if (sizeJ <= 1024) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 2944) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 3584) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 5056) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 5888) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
      }
      if (sizeI <= 448) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1";
        if (sizeJ <= 64) return "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4";
        if (sizeJ <= 256) return "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4";
        if (sizeJ <= 448) return "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn1";
        if (sizeJ <= 704) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1024) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 1408) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1856) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 2368) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 2944) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 3584) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 4288) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 5056) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 5888) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
      }
      if (sizeI <= 704) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT008x008x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1";
        if (sizeJ <= 64) return "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn1";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 448) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 704) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 1024) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1408) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 1856) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 2368) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 2944) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 5888) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4";
      }
      if (sizeI <= 1024) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1";
        if (sizeJ <= 64) return "Cijk_Alik_Bjlk_SB_MT016x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG04_08_04_WGMn4";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 256) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 704) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 1408) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 1856) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 2368) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 2944) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 3584) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 4288) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4";
      }
      if (sizeI <= 1408) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT008x008x08_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGMn1";
        if (sizeJ <= 64) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 704) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1408) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 2368) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 4288) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 5056) return "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 5888) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4";
        return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
      }
      if (sizeI <= 1856) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1";
        if (sizeJ <= 64) return "Cijk_Alik_Bjlk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGMn4";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 256) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 448) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 704) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1856) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 2368) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 3584) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 4288) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 5888) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1";
        return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
      }
      if (sizeI <= 2368) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1";
        if (sizeJ <= 64) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1";
        if (sizeJ <= 256) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 448) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 704) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 1024) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 1856) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 2368) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 2944) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 4288) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 5056) return "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1";
        return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
      }
      if (sizeI <= 2944) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1";
        if (sizeJ <= 64) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 256) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 448) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 704) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1024) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 1408) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1856) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 2368) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 5056) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        return "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1";
      }
      if (sizeI <= 3584) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 256) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 448) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 704) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 1024) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 1856) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 2944) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4";
      }
      if (sizeI <= 4288) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1";
        if (sizeJ <= 64) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 256) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 448) return "Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 704) return "Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1024) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 1856) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 2368) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 3584) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 4288) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 5056) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
        return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4";
      }
      if (sizeI <= 5056) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1";
        if (sizeJ <= 256) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 448) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 704) return "Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1408) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1856) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 3584) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 5056) return "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 5888) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4";
        return "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1";
      }
      if (sizeI <= 5888) {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1";
        if (sizeJ <= 64) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn4";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 256) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 704) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1408) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1856) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 2368) return "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 2944) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 3584) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 4288) return "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 5056) return "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn4";
        return "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1";
      }
      {
        if (sizeJ <= 4) return "Cijk_Alik_Bjlk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGMn1";
        if (sizeJ <= 64) return "Cijk_Alik_Bjlk_SB_MT032x064x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_16_02_WGMn1";
        if (sizeJ <= 128) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 256) return "Cijk_Alik_Bjlk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 448) return "Cijk_Alik_Bjlk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1024) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 1408) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn4";
        if (sizeJ <= 1856) return "Cijk_Alik_Bjlk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 2368) return "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1";
        if (sizeJ <= 3584) return "Cijk_Alik_Bjlk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGMn4";
        return "Cijk_Alik_Bjlk_SB_MT128x128x24_GSU01_NLCA03_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGMn1";
      }
    }
  }

}
/*******************************************************************************
 * Per-ProblemType Functions
 *******************************************************************************/
// return solution PointerUncached
TensileSolutionPointer_Cijk_Alik_Bjlk_SB tensileGetSolutionPointerUncached_Cijk_Alik_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionPointerUncached_Tensile_Cijk_Alik_Bjlk_SB(strideC1J, strideC2K, strideA1I, strideA2K, strideB1L, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution Name
const char *tensileGetSolutionName_Cijk_Alik_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionName_Tensile_Cijk_Alik_Bjlk_SB(strideC1J, strideC2K, strideA1I, strideA2K, strideB1L, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution pointer; user calls it
Map_Cijk_Alik_Bjlk_SB solutionMap_Cijk_Alik_Bjlk_SB;
TensileSolutionPointer_Cijk_Alik_Bjlk_SB tensileGetSolutionPointer_Cijk_Alik_Bjlk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  ProblemSizeKey key = std::make_tuple( sizeI, sizeJ, sizeL );
  Map_Cijk_Alik_Bjlk_SB::iterator iter = solutionMap_Cijk_Alik_Bjlk_SB.find(key);
  if (iter != solutionMap_Cijk_Alik_Bjlk_SB.end()) {
    return iter->second;
  } else {
    TensileSolutionPointer_Cijk_Alik_Bjlk_SB ptr = tensileGetSolutionPointerUncached_Cijk_Alik_Bjlk_SB(
        strideC1J,
        strideC2K,
        strideA1I,
        strideA2K,
        strideB1L,
        strideB2K,
        sizeI,
        sizeJ,
        sizeK,
        sizeL,
        stream);
    solutionMap_Cijk_Alik_Bjlk_SB[key] = ptr;
    return ptr;
  }
}

// main call to solution; enqueues a kernel
TensileStatus tensile_Cijk_Alik_Bjlk_SB(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1L,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
    TensileSolutionPointer_Cijk_Alik_Bjlk_SB ptr = tensileGetSolutionPointer_Cijk_Alik_Bjlk_SB(
        strideC1J, 
        strideC2K, 
        strideA1I, 
        strideA2K, 
        strideB1L, 
        strideB2K, 
        sizeI, 
        sizeJ, 
        sizeK, 
        sizeL, 
        stream);
    if ( ptr ) {
      return ptr(dataC, dataA, dataB, alpha, beta, offsetC, offsetA, offsetB, strideC1J, strideC2K, strideA1I, strideA2K, strideB1L, strideB2K, sizeI, sizeJ, sizeK, sizeL, stream, numInputEvents, inputEvents, outputEvent);
    } else {
      return tensileStatusFailure; // no solution found
    }
}
/*******************************************************************************
 * Per-Schedule Functions
 *******************************************************************************/
// problem size -> solution logic
TensileSolutionPointer_Cijk_Alik_Bljk_DB tensileGetSolutionPointerUncached_Tensile_Cijk_Alik_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */

  /* range mappings */
  {
    {
      if (sizeI <= 1) {
        return Cijk_Alik_Bljk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08;
      }
      {
        if (sizeJ <= 1) return Cijk_Alik_Bljk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08;
        return Cijk_Alik_Bljk_DB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08;
      }
    }
  }

}

// get solution name for problem size
const char * tensileGetSolutionName_Tensile_Cijk_Alik_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */

  /* range mappings */
  {
    {
      if (sizeI <= 1) {
        return "Cijk_Alik_Bljk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08";
      }
      {
        if (sizeJ <= 1) return "Cijk_Alik_Bljk_DB_MT064x064x04_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08";
        return "Cijk_Alik_Bljk_DB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW02_WG16_16_01_WGM08";
      }
    }
  }

}
/*******************************************************************************
 * Per-ProblemType Functions
 *******************************************************************************/
// return solution PointerUncached
TensileSolutionPointer_Cijk_Alik_Bljk_DB tensileGetSolutionPointerUncached_Cijk_Alik_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionPointerUncached_Tensile_Cijk_Alik_Bljk_DB(strideC1J, strideC2K, strideA1I, strideA2K, strideB1J, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution Name
const char *tensileGetSolutionName_Cijk_Alik_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionName_Tensile_Cijk_Alik_Bljk_DB(strideC1J, strideC2K, strideA1I, strideA2K, strideB1J, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution pointer; user calls it
Map_Cijk_Alik_Bljk_DB solutionMap_Cijk_Alik_Bljk_DB;
TensileSolutionPointer_Cijk_Alik_Bljk_DB tensileGetSolutionPointer_Cijk_Alik_Bljk_DB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  ProblemSizeKey key = std::make_tuple( sizeI, sizeJ, sizeL );
  Map_Cijk_Alik_Bljk_DB::iterator iter = solutionMap_Cijk_Alik_Bljk_DB.find(key);
  if (iter != solutionMap_Cijk_Alik_Bljk_DB.end()) {
    return iter->second;
  } else {
    TensileSolutionPointer_Cijk_Alik_Bljk_DB ptr = tensileGetSolutionPointerUncached_Cijk_Alik_Bljk_DB(
        strideC1J,
        strideC2K,
        strideA1I,
        strideA2K,
        strideB1J,
        strideB2K,
        sizeI,
        sizeJ,
        sizeK,
        sizeL,
        stream);
    solutionMap_Cijk_Alik_Bljk_DB[key] = ptr;
    return ptr;
  }
}

// main call to solution; enqueues a kernel
TensileStatus tensile_Cijk_Alik_Bljk_DB(
    double * dataC,
    const double * dataA,
    const double * dataB,
    double alpha,
    double beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1I,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
    TensileSolutionPointer_Cijk_Alik_Bljk_DB ptr = tensileGetSolutionPointer_Cijk_Alik_Bljk_DB(
        strideC1J, 
        strideC2K, 
        strideA1I, 
        strideA2K, 
        strideB1J, 
        strideB2K, 
        sizeI, 
        sizeJ, 
        sizeK, 
        sizeL, 
        stream);
    if ( ptr ) {
      return ptr(dataC, dataA, dataB, alpha, beta, offsetC, offsetA, offsetB, strideC1J, strideC2K, strideA1I, strideA2K, strideB1J, strideB2K, sizeI, sizeJ, sizeK, sizeL, stream, numInputEvents, inputEvents, outputEvent);
    } else {
      return tensileStatusFailure; // no solution found
    }
}
/*******************************************************************************
 * Per-Schedule Functions
 *******************************************************************************/
// problem size -> solution logic
TensileSolutionPointer_Cijk_Ailk_Bljk_SB tensileGetSolutionPointerUncached_Tensile_Cijk_Ailk_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */
  if ( sizeI == 4096 && sizeJ == 7000 && sizeK == 1 && sizeL == 4096 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9905 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 1760 ) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08; // 9877 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9770 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 32 && sizeK == 1 && sizeL == 1760 ) return Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01; // 2941 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 1500 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 7817 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 8926 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 24000 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9197 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 3000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 8921 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 4 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01; // 751 GFlop/s
  else if ( sizeI == 35 && sizeJ == 1500 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01; // 1842 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 1500 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08; // 9354 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 7000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9525 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 16 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01; // 1669 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01; // 9405 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 64 && sizeK == 1 && sizeL == 1760 ) return Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08; // 3954 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 16 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bljk_SB_MT016x016x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01; // 618 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9301 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 32 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01; // 3650 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 1500 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 8901 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 128 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08; // 4331 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9572 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 3000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 9160 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9526 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 700 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08; // 4948 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 1 && sizeK == 1 && sizeL == 128 ) return Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01; // 30 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 700 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08; // 8486 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 16 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08; // 2814 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 6000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9821 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 32 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08; // 3425 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT048x036x16_GSU04_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01; // 3523 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 64 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08; // 2996 GFlop/s
  else if ( sizeI == 512 && sizeJ == 16 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08; // 364 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 2 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01; // 374 GFlop/s
  else if ( sizeI == 4224 && sizeJ == 1 && sizeK == 1 && sizeL == 128 ) return Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01; // 39 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 1 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01; // 189 GFlop/s
  else if ( sizeI == 128 && sizeJ == 1500 && sizeK == 1 && sizeL == 1280 ) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01; // 4246 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 4096 ) return Cijk_Ailk_Bljk_SB_MT048x036x16_GSU08_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01; // 3779 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 1500 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 8488 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 2 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01; // 363 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 48000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM08; // 9948 GFlop/s
  else if ( sizeI == 512 && sizeJ == 6000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01; // 8329 GFlop/s
  else if ( sizeI == 4224 && sizeJ == 1500 && sizeK == 1 && sizeL == 176 ) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01; // 5194 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 6000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM08; // 9396 GFlop/s
  else if ( sizeI == 512 && sizeJ == 6000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 8766 GFlop/s
  else if ( sizeI == 512 && sizeJ == 32 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bljk_SB_MT064x008x32_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01; // 655 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 128 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08; // 5754 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 24000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9837 GFlop/s
  else if ( sizeI == 512 && sizeJ == 2 && sizeK == 1 && sizeL == 500000 ) return Cijk_Ailk_Bljk_SB_MT064x008x32_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_02_08_WGM01; // 440 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9920 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 48000 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01; // 9368 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 16 && sizeK == 1 && sizeL == 1760 ) return Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01; // 1717 GFlop/s
  else if ( sizeI == 512 && sizeJ == 3000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 8488 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 7000 && sizeK == 1 && sizeL == 1760 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 9504 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 3000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01; // 8367 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 4 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01; // 709 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 6000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01; // 8709 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9716 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9968 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 3000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9914 GFlop/s
  else if ( sizeI == 35 && sizeJ == 1500 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT036x048x16_GSU08_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01; // 2258 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 4 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01; // 462 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 48000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 10166 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 32 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08; // 2743 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 1500 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 9393 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 128 && sizeK == 1 && sizeL == 4096 ) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08; // 6576 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 16 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01; // 2262 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 1500 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01; // 7690 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 3000 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01; // 8155 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 2 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08; // 233 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 1 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01; // 190 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9982 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 3000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 9014 GFlop/s
  else if ( sizeI == 128 && sizeJ == 1 && sizeK == 1 && sizeL == 1408 ) return Cijk_Ailk_Bljk_SB_MT032x008x64_GSU32_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_04_08_WGM01; // 18 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 1760 ) return Cijk_Ailk_Bljk_SB_MT048x036x16_GSU02_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01; // 3788 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 2 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bljk_SB_MT032x008x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01; // 82 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 4 && sizeK == 1 && sizeL == 500000 ) return Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01; // 882 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 1 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT064x008x32_GSU32_NLCA01_NLCB01_PGR0_TT04_02_VW02_WG16_04_04_WGM01; // 182 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 10068 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9878 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 16 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01; // 1876 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9319 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 6000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 10022 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 128 && sizeK == 1 && sizeL == 1760 ) return Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08; // 5305 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT048x048x16_GSU08_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01; // 3214 GFlop/s
  else if ( sizeI == 512 && sizeJ == 1500 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08; // 7709 GFlop/s
  else if ( sizeI == 512 && sizeJ == 1 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bljk_SB_MT064x004x64_GSU16_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG32_02_04_WGM01; // 28 GFlop/s
  else if ( sizeI == 512 && sizeJ == 16 && sizeK == 1 && sizeL == 500000 ) return Cijk_Ailk_Bljk_SB_MT064x016x32_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01; // 3351 GFlop/s
  else if ( sizeI == 512 && sizeJ == 8 && sizeK == 1 && sizeL == 500000 ) return Cijk_Ailk_Bljk_SB_MT064x008x32_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_02_08_WGM01; // 1732 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9499 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 3000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9602 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9685 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 7000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9057 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 3000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9699 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 4 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01; // 167 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 700 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08; // 7698 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 4096 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9844 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 64 && sizeK == 1 && sizeL == 4096 ) return Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08; // 5551 GFlop/s
  else if ( sizeI == 512 && sizeJ == 6000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08; // 7660 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 32 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08; // 4793 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 64 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01; // 4899 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 128 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08; // 3590 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 6000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 10275 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 64 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08; // 5902 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 1500 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 8828 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 1500 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 8322 GFlop/s
  else if ( sizeI == 512 && sizeJ == 4 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01; // 98 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 6000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 9149 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 32 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08; // 2403 GFlop/s
  else if ( sizeI == 35 && sizeJ == 700 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08; // 1785 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 1 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG16_04_04_WGM01; // 158 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 32 && sizeK == 1 && sizeL == 4096 ) return Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01; // 4491 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 10394 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 4 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08; // 746 GFlop/s
  else if ( sizeI == 64 && sizeJ == 1 && sizeK == 1 && sizeL == 1216 ) return Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01; // 6 GFlop/s
  else if ( sizeI == 512 && sizeJ == 1 && sizeK == 1 && sizeL == 500000 ) return Cijk_Ailk_Bljk_SB_MT064x008x32_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_02_08_WGM01; // 220 GFlop/s
  else if ( sizeI == 176 && sizeJ == 1500 && sizeK == 1 && sizeL == 1408 ) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01; // 4510 GFlop/s
  else if ( sizeI == 512 && sizeJ == 3000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01; // 7705 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 24000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 10338 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 2 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG16_04_04_WGM01; // 311 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9499 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 128 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01; // 7802 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 6000 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01; // 8678 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 1500 && sizeK == 1 && sizeL == 128 ) return Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08; // 3854 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 3000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01; // 8454 GFlop/s
  else if ( sizeI == 512 && sizeJ == 4 && sizeK == 1 && sizeL == 500000 ) return Cijk_Ailk_Bljk_SB_MT064x016x64_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01; // 874 GFlop/s
  else if ( sizeI == 35 && sizeJ == 700 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08; // 1443 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 16 && sizeK == 1 && sizeL == 500000 ) return Cijk_Ailk_Bljk_SB_MT128x016x16_GSU16_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_08_02_WGM01; // 3383 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01; // 8881 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 32 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01; // 1039 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9898 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 16 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01; // 2146 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 64 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01; // 3801 GFlop/s
  else if ( sizeI == 512 && sizeJ == 2 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01; // 45 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 1 && sizeK == 1 && sizeL == 512 ) return Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01; // 40 GFlop/s
  else if ( sizeI == 512 && sizeJ == 1500 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01; // 7414 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 32 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01; // 4468 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 1 && sizeK == 1 && sizeL == 500000 ) return Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01; // 222 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 16 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01; // 2760 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01; // 9361 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 16 && sizeK == 1 && sizeL == 4096 ) return Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01; // 2871 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 1500 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08; // 8455 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 1500 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01; // 7659 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 2 && sizeK == 1 && sizeL == 500000 ) return Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01; // 442 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 8 && sizeK == 1 && sizeL == 500000 ) return Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01; // 1750 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 16 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01; // 2803 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 1500 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9262 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 1 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bljk_SB_MT032x008x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01; // 122 GFlop/s
  else if ( sizeI == 512 && sizeJ == 6000 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01; // 8986 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 2 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01; // 380 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 4 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08; // 599 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 6000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 8833 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 32 && sizeK == 1 && sizeL == 2816 ) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08; // 4884 GFlop/s
  else if ( sizeI == 512 && sizeJ == 3000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 7051 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 10336 GFlop/s
  else if ( sizeI == 512 && sizeJ == 3000 && sizeK == 1 && sizeL == 2560 ) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08; // 8259 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 6000 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9410 GFlop/s
  else if ( sizeI == 512 && sizeJ == 1500 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01; // 5868 GFlop/s
  else if ( sizeI == 512 && sizeJ == 1500 && sizeK == 1 && sizeL == 1536 ) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08; // 6906 GFlop/s
  else if ( sizeI == 128 && sizeJ == 1 && sizeK == 1 && sizeL == 1024 ) return Cijk_Ailk_Bljk_SB_MT128x008x32_GSU32_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_04_04_WGM01; // 12 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 2048 ) return Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01; // 9678 GFlop/s

  /* range mappings */
  {
    {
      if (sizeI <= 4) {
        return Cijk_Ailk_Bljk_SB_MT016x016x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01;
      }
      if (sizeI <= 64) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 256) return Cijk_Ailk_Bljk_SB_MT064x008x32_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 704) return Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 1024) return Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 1408) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 1856) return Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 2368) return Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01;
        if (sizeJ <= 2944) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 3584) return Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 5056) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
      }
      if (sizeI <= 128) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01;
        if (sizeJ <= 256) return Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01;
        if (sizeJ <= 704) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 1024) return Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 1408) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 1856) return Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 2944) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 3584) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5056) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 5888) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 256) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 704) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1024) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1408) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2368) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2944) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 3584) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 4288) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5056) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5888) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08;
        return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 448) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 256) return Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08;
        if (sizeJ <= 1408) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1856) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2944) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 3584) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 4288) return Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5056) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5888) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        return Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 704) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 256) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1024) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1408) return Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2368) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2944) return Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5888) return Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01;
        return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 1024) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT128x032x16_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 704) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2944) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 3584) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 4288) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5056) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5888) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01;
        return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08;
      }
      if (sizeI <= 1408) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1856) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5056) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5888) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 1856) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 704) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1024) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1408) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1856) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2944) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 3584) return Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 4288) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5056) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5888) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 2368) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x04_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1024) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1856) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2944) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 3584) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 4288) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5056) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 2944) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x04_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 704) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1408) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1856) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2368) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 4288) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5056) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 5888) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01;
        return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
      }
      if (sizeI <= 3584) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x08_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1024) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1408) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1856) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08;
        if (sizeJ <= 3584) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 4288) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5056) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 4288) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1024) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1408) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1856) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 2944) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 3584) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 5056) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 5056) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1408) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1856) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 3584) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 4288) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01;
      }
      if (sizeI <= 5888) {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT008x008x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 256) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1024) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1408) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 2368) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01;
      }
      {
        if (sizeJ <= 4) return Cijk_Ailk_Bljk_SB_MT016x016x08_GSU01_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01;
        if (sizeJ <= 64) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 128) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 256) return Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 448) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 704) return Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 1024) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 1856) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        if (sizeJ <= 3584) return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01;
        if (sizeJ <= 4288) return Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08;
        return Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01;
      }
    }
  }

}

// get solution name for problem size
const char * tensileGetSolutionName_Tensile_Cijk_Ailk_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL) {

  /* exact mappings */
  if ( sizeI == 4096 && sizeJ == 7000 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9905 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08~"; // 9877 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9770 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 32 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01~"; // 2941 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 1500 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 7817 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 8926 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 24000 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9197 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 3000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 8921 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 4 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01~"; // 751 GFlop/s
  else if ( sizeI == 35 && sizeJ == 1500 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01~"; // 1842 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 1500 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08~"; // 9354 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 7000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9525 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 16 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01~"; // 1669 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01~"; // 9405 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 64 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08~"; // 3954 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 16 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bljk_SB_MT016x016x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01~"; // 618 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9301 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 32 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01~"; // 3650 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 1500 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 8901 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 128 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08~"; // 4331 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9572 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 3000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 9160 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9526 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 700 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08~"; // 4948 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 1 && sizeK == 1 && sizeL == 128 ) return "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01~"; // 30 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 700 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08~"; // 8486 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 16 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08~"; // 2814 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 6000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9821 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 32 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_02_WGM08~"; // 3425 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT048x036x16_GSU04_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01~"; // 3523 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 64 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM08~"; // 2996 GFlop/s
  else if ( sizeI == 512 && sizeJ == 16 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM08~"; // 364 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 2 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01~"; // 374 GFlop/s
  else if ( sizeI == 4224 && sizeJ == 1 && sizeK == 1 && sizeL == 128 ) return "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01~"; // 39 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 1 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01~"; // 189 GFlop/s
  else if ( sizeI == 128 && sizeJ == 1500 && sizeK == 1 && sizeL == 1280 ) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01~"; // 4246 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Ailk_Bljk_SB_MT048x036x16_GSU08_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01~"; // 3779 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 1500 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 8488 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 2 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_08_02_WGM01~"; // 363 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 48000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM08~"; // 9948 GFlop/s
  else if ( sizeI == 512 && sizeJ == 6000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01~"; // 8329 GFlop/s
  else if ( sizeI == 4224 && sizeJ == 1500 && sizeK == 1 && sizeL == 176 ) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01~"; // 5194 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 6000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM08~"; // 9396 GFlop/s
  else if ( sizeI == 512 && sizeJ == 6000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 8766 GFlop/s
  else if ( sizeI == 512 && sizeJ == 32 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01~"; // 655 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 128 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08~"; // 5754 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 24000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9837 GFlop/s
  else if ( sizeI == 512 && sizeJ == 2 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_02_08_WGM01~"; // 440 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9920 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 48000 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01~"; // 9368 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 16 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01~"; // 1717 GFlop/s
  else if ( sizeI == 512 && sizeJ == 3000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 8488 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 7000 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 9504 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 3000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01~"; // 8367 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 4 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01~"; // 709 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 6000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01~"; // 8709 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9716 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9968 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 3000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9914 GFlop/s
  else if ( sizeI == 35 && sizeJ == 1500 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT036x048x16_GSU08_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG12_16_01_WGM01~"; // 2258 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 4 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01~"; // 462 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 48000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 10166 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 32 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08~"; // 2743 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 1500 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 9393 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 128 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08~"; // 6576 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 16 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01~"; // 2262 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 1500 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01~"; // 7690 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 3000 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01~"; // 8155 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 2 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08~"; // 233 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 1 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01~"; // 190 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9982 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 3000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 9014 GFlop/s
  else if ( sizeI == 128 && sizeJ == 1 && sizeK == 1 && sizeL == 1408 ) return "Cijk_Ailk_Bljk_SB_MT032x008x64_GSU32_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_04_08_WGM01~"; // 18 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Ailk_Bljk_SB_MT048x036x16_GSU02_NLCA01_NLCB01_PGR1_TT06_03_VW01_WG08_12_02_WGM01~"; // 3788 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 2 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01~"; // 82 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 4 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01~"; // 882 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 1 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU32_NLCA01_NLCB01_PGR0_TT04_02_VW02_WG16_04_04_WGM01~"; // 182 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 10068 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9878 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 16 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT032x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01~"; // 1876 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9319 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 6000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 10022 GFlop/s
  else if ( sizeI == 1760 && sizeJ == 128 && sizeK == 1 && sizeL == 1760 ) return "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08~"; // 5305 GFlop/s
  else if ( sizeI == 35 && sizeJ == 8457 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT048x048x16_GSU08_NLCA03_NLCB01_PGR1_TT03_03_VW01_WG16_16_01_WGM01~"; // 3214 GFlop/s
  else if ( sizeI == 512 && sizeJ == 1500 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08~"; // 7709 GFlop/s
  else if ( sizeI == 512 && sizeJ == 1 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bljk_SB_MT064x004x64_GSU16_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG32_02_04_WGM01~"; // 28 GFlop/s
  else if ( sizeI == 512 && sizeJ == 16 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01~"; // 3351 GFlop/s
  else if ( sizeI == 512 && sizeJ == 8 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_02_08_WGM01~"; // 1732 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9499 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 3000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9602 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9685 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 7000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9057 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 3000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9699 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 4 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01~"; // 167 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 700 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08~"; // 7698 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 9124 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9844 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 64 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08~"; // 5551 GFlop/s
  else if ( sizeI == 512 && sizeJ == 6000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08~"; // 7660 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 32 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08~"; // 4793 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 64 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01~"; // 4899 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 128 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08~"; // 3590 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 6000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 10275 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 64 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08~"; // 5902 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 1500 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 8828 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 1500 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 8322 GFlop/s
  else if ( sizeI == 512 && sizeJ == 4 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01~"; // 98 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 6000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 9149 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 32 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08~"; // 2403 GFlop/s
  else if ( sizeI == 35 && sizeJ == 700 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08~"; // 1785 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 1 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG16_04_04_WGM01~"; // 158 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 32 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01~"; // 4491 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 10394 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 4 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08~"; // 746 GFlop/s
  else if ( sizeI == 64 && sizeJ == 1 && sizeK == 1 && sizeL == 1216 ) return "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01~"; // 6 GFlop/s
  else if ( sizeI == 512 && sizeJ == 1 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU16_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_02_08_WGM01~"; // 220 GFlop/s
  else if ( sizeI == 176 && sizeJ == 1500 && sizeK == 1 && sizeL == 1408 ) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01~"; // 4510 GFlop/s
  else if ( sizeI == 512 && sizeJ == 3000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01~"; // 7705 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 24000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 10338 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 2 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_NLCA01_NLCB01_PGR0_TT02_02_VW02_WG16_04_04_WGM01~"; // 311 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9499 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 128 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01~"; // 7802 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 6000 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01~"; // 8678 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 1500 && sizeK == 1 && sizeL == 128 ) return "Cijk_Ailk_Bljk_SB_MT064x064x08_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08~"; // 3854 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 3000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01~"; // 8454 GFlop/s
  else if ( sizeI == 512 && sizeJ == 4 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Ailk_Bljk_SB_MT064x016x64_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG16_04_04_WGM01~"; // 874 GFlop/s
  else if ( sizeI == 35 && sizeJ == 700 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM08~"; // 1443 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 16 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU16_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_08_02_WGM01~"; // 3383 GFlop/s
  else if ( sizeI == 512 && sizeJ == 24000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01~"; // 8881 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 32 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01~"; // 1039 GFlop/s
  else if ( sizeI == 512 && sizeJ == 48000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9898 GFlop/s
  else if ( sizeI == 2560 && sizeJ == 16 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01~"; // 2146 GFlop/s
  else if ( sizeI == 2048 && sizeJ == 64 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01~"; // 3801 GFlop/s
  else if ( sizeI == 512 && sizeJ == 2 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01~"; // 45 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 1 && sizeK == 1 && sizeL == 512 ) return "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01~"; // 40 GFlop/s
  else if ( sizeI == 512 && sizeJ == 1500 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01~"; // 7414 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 32 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01~"; // 4468 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 1 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01~"; // 222 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 16 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_02_WGM01~"; // 2760 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 24000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01~"; // 9361 GFlop/s
  else if ( sizeI == 4096 && sizeJ == 16 && sizeK == 1 && sizeL == 4096 ) return "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01~"; // 2871 GFlop/s
  else if ( sizeI == 5124 && sizeJ == 1500 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08~"; // 8455 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 1500 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM01~"; // 7659 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 2 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01~"; // 442 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 8 && sizeK == 1 && sizeL == 500000 ) return "Cijk_Ailk_Bljk_SB_MT128x008x32_GSU16_NLCA01_NLCB01_PGR0_TT04_04_VW04_WG32_02_04_WGM01~"; // 1750 GFlop/s
  else if ( sizeI == 7680 && sizeJ == 16 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG32_04_02_WGM01~"; // 2803 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 1500 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9262 GFlop/s
  else if ( sizeI == 3072 && sizeJ == 1 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01~"; // 122 GFlop/s
  else if ( sizeI == 512 && sizeJ == 6000 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01~"; // 8986 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 2 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01~"; // 380 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 4 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT064x016x16_GSU02_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_08_02_WGM08~"; // 599 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 6000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 8833 GFlop/s
  else if ( sizeI == 8448 && sizeJ == 32 && sizeK == 1 && sizeL == 2816 ) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08~"; // 4884 GFlop/s
  else if ( sizeI == 512 && sizeJ == 3000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 7051 GFlop/s
  else if ( sizeI == 6144 && sizeJ == 24000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 10336 GFlop/s
  else if ( sizeI == 512 && sizeJ == 3000 && sizeK == 1 && sizeL == 2560 ) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08~"; // 8259 GFlop/s
  else if ( sizeI == 4608 && sizeJ == 6000 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9410 GFlop/s
  else if ( sizeI == 512 && sizeJ == 1500 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01~"; // 5868 GFlop/s
  else if ( sizeI == 512 && sizeJ == 1500 && sizeK == 1 && sizeL == 1536 ) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08~"; // 6906 GFlop/s
  else if ( sizeI == 128 && sizeJ == 1 && sizeK == 1 && sizeL == 1024 ) return "Cijk_Ailk_Bljk_SB_MT128x008x32_GSU32_NLCA01_NLCB01_PGR0_TT08_02_VW02_WG16_04_04_WGM01~"; // 12 GFlop/s
  else if ( sizeI == 1024 && sizeJ == 48000 && sizeK == 1 && sizeL == 2048 ) return "Cijk_Ailk_Bljk_SB_MT128x128x16_GSU01_NLCA01_NLCB01_PGR0_TT08_08_VW04_WG16_16_01_WGM01~"; // 9678 GFlop/s

  /* range mappings */
  {
    {
      if (sizeI <= 4) {
        return "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01";
      }
      if (sizeI <= 64) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bljk_SB_MT032x008x32_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG16_04_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 256) return "Cijk_Ailk_Bljk_SB_MT064x008x32_GSU04_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG16_04_04_WGM01";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 704) return "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
      }
      if (sizeI <= 128) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bljk_SB_MT032x016x16_GSU08_NLCA01_NLCB01_PGR1_TT04_02_VW02_WG08_08_04_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01";
        if (sizeJ <= 256) return "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01";
        if (sizeJ <= 704) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 256) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bljk_SB_MT064x016x32_GSU08_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_04_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 704) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 448) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 256) return "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM01";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        return "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 704) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bljk_SB_MT032x032x32_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_04_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 256) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM01";
        return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 1024) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG08_08_04_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT128x032x16_GSU02_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 704) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01";
        return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08";
      }
      if (sizeI <= 1408) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 1856) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x16_GSU16_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bljk_SB_MT064x032x32_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 704) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bljk_SB_MT064x128x16_GSU01_NLCA01_NLCB01_PGR1_TT04_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 2368) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x04_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 2944) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x04_GSU08_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_01_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 704) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 5888) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01";
        return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
      }
      if (sizeI <= 3584) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU04_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bljk_SB_MT128x096x16_GSU01_NLCA01_NLCB01_PGR1_TT08_06_VW02_WG16_16_01_WGM08";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 4288) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT032x032x16_GSU04_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG08_08_02_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 2944) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 5056) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 5056) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01";
      }
      if (sizeI <= 5888) {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT008x008x08_GSU02_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG04_04_04_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bljk_SB_MT064x032x16_GSU02_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_08_02_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 256) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1408) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 2368) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01";
      }
      {
        if (sizeJ <= 4) return "Cijk_Ailk_Bljk_SB_MT016x016x08_GSU01_NLCA01_NLCB01_PGR1_TT02_02_VW02_WG08_08_02_WGM01";
        if (sizeJ <= 64) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 128) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 256) return "Cijk_Ailk_Bljk_SB_MT064x064x16_GSU01_NLCA01_NLCB01_PGR1_TT04_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 448) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 704) return "Cijk_Ailk_Bljk_SB_MT128x128x08_GSU01_NLCA01_NLCB01_PGR1_TT08_08_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 1024) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 1856) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        if (sizeJ <= 3584) return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01";
        if (sizeJ <= 4288) return "Cijk_Ailk_Bljk_SB_MT128x064x16_GSU01_NLCA01_NLCB01_PGR1_TT08_04_VW04_WG16_16_01_WGM08";
        return "Cijk_Ailk_Bljk_SB_MT128x128x24_GSU01_NLCA01_NLCB03_PGR0_TT08_08_VW04_WG16_16_01_WGM01";
      }
    }
  }

}
/*******************************************************************************
 * Per-ProblemType Functions
 *******************************************************************************/
// return solution PointerUncached
TensileSolutionPointer_Cijk_Ailk_Bljk_SB tensileGetSolutionPointerUncached_Cijk_Ailk_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionPointerUncached_Tensile_Cijk_Ailk_Bljk_SB(strideC1J, strideC2K, strideA1L, strideA2K, strideB1J, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution Name
const char *tensileGetSolutionName_Cijk_Ailk_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  return tensileGetSolutionName_Tensile_Cijk_Ailk_Bljk_SB(strideC1J, strideC2K, strideA1L, strideA2K, strideB1J, strideB2K, sizeI, sizeJ, sizeK, sizeL);

}

// return solution pointer; user calls it
Map_Cijk_Ailk_Bljk_SB solutionMap_Cijk_Ailk_Bljk_SB;
TensileSolutionPointer_Cijk_Ailk_Bljk_SB tensileGetSolutionPointer_Cijk_Ailk_Bljk_SB(
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream) {
  ProblemSizeKey key = std::make_tuple( sizeI, sizeJ, sizeL );
  Map_Cijk_Ailk_Bljk_SB::iterator iter = solutionMap_Cijk_Ailk_Bljk_SB.find(key);
  if (iter != solutionMap_Cijk_Ailk_Bljk_SB.end()) {
    return iter->second;
  } else {
    TensileSolutionPointer_Cijk_Ailk_Bljk_SB ptr = tensileGetSolutionPointerUncached_Cijk_Ailk_Bljk_SB(
        strideC1J,
        strideC2K,
        strideA1L,
        strideA2K,
        strideB1J,
        strideB2K,
        sizeI,
        sizeJ,
        sizeK,
        sizeL,
        stream);
    solutionMap_Cijk_Ailk_Bljk_SB[key] = ptr;
    return ptr;
  }
}

// main call to solution; enqueues a kernel
TensileStatus tensile_Cijk_Ailk_Bljk_SB(
    float * dataC,
    const float * dataA,
    const float * dataB,
    float alpha,
    float beta,
    unsigned int offsetC,
    unsigned int offsetA,
    unsigned int offsetB,
    unsigned int strideC1J,
    unsigned int strideC2K,
    unsigned int strideA1L,
    unsigned int strideA2K,
    unsigned int strideB1J,
    unsigned int strideB2K,
    unsigned int sizeI,
    unsigned int sizeJ,
    unsigned int sizeK,
    unsigned int sizeL,
    hipStream_t stream,
    unsigned int numInputEvents,
    hipEvent_t * inputEvents,
    hipEvent_t * outputEvent) {
    TensileSolutionPointer_Cijk_Ailk_Bljk_SB ptr = tensileGetSolutionPointer_Cijk_Ailk_Bljk_SB(
        strideC1J, 
        strideC2K, 
        strideA1L, 
        strideA2K, 
        strideB1J, 
        strideB2K, 
        sizeI, 
        sizeJ, 
        sizeK, 
        sizeL, 
        stream);
    if ( ptr ) {
      return ptr(dataC, dataA, dataB, alpha, beta, offsetC, offsetA, offsetB, strideC1J, strideC2K, strideA1L, strideA2K, strideB1J, strideB2K, sizeI, sizeJ, sizeK, sizeL, stream, numInputEvents, inputEvents, outputEvent);
    } else {
      return tensileStatusFailure; // no solution found
    }
}
